/*================================================================================================================*/
// *********************************** THESE ARE THE MAP INFORMATIONS: ****************************************** //
/*================================================================================================================*/
// CREATED BY DANY:
// NOVEMBER 2006
// TEXAS BY ENSEMBLE:
// OCTOBER 2003:
/*================================================================================================================*/
// *********************************** MAIN ENTRY POINT FOR RANDOM MAP SCRIPT: ********************************** //
/*================================================================================================================*/
include "mercenaries.xs";
void main(void)
{
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.01);
/*================================================================================================================*/
// *************************************** CHOOSES THE NATIVE TRIBES: ******************************************* //
/*================================================================================================================*/
        int subCiv0=-1;
        int subCiv1=-1;
        int subCiv2=-1;
	    int subCiv3=-1;
/*----------------------------------------------------------------------------------------------------------------*/		
		  // ALL IROQUOIS ALL THE TIME:
        if (rmAllocateSubCivs(4) == true)
/*----------------------------------------------------------------------------------------------------------------*/		
   {
/*----------------------------------------------------------------------------------------------------------------*/   
		subCiv0=rmGetCivID("Maya");
        if (subCiv0 >= 0)
        rmSetSubCiv(0, "Maya");

		subCiv1=rmGetCivID("Maya");
        if (subCiv1 >= 0)
        rmSetSubCiv(1, "Maya");

		subCiv2=rmGetCivID("Maya");
        if (subCiv2 >= 0)
        rmSetSubCiv(2, "Maya");

		subCiv3=rmGetCivID("Maya");
        if (subCiv3 >= 0)
        rmSetSubCiv(3, "Maya");
/*----------------------------------------------------------------------------------------------------------------*/		
	}
/*================================================================================================================*/
// ***************************************** PICKS THE MAP SIZE: ************************************************ //
/*================================================================================================================*/
	// int playerTiles=10000;
	   int playerTiles=25000;
	
	// if (cNumberNonGaiaPlayers >4)
	//	playerTiles = 9500;

	int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
	rmEchoInfo("Map size="+size+"m x "+size+"m");
	rmSetMapSize(size, size);
/*================================================================================================================*/
// *************************************** PICKS THE MAP PARAMETERS: ******************************************** //
/*================================================================================================================*/
      // SET THE MAP ELEVATION PARAMETERS:
	  // rmSetMapElevationParameters(cElevTurbulence, 0.4, 6, 0.5, 3.0);  // DAL - original
	  rmSetMapElevationParameters(cElevTurbulence, 0.4, 6, 0.7, 5.0);
	  rmSetMapElevationHeightBlend(1);
	
	  // PICKS A DEFAULT WATER HEIGHT:
	  // rmSetSeaLevel(4.0);
	     // rmSetSeaLevel(1.0); // FROM SAGUENAY:
		    rmSetSeaLevel(1.0); // FROM PATAGONIA:
	  
	  // PICKS THE LIGHTING:
	  // rmSetLightingSet("Texas");
	     // rmSetLightingSet("saguenay"); // FROM SAGUENAY:
		    rmSetLightingSet("patagonia"); // FROM PATAGONIA:

      // PICKS THE DEFAULT TERRAIN AND WATER:
	  // rmSetSeaType("Amazon River");
	     // rmSetSeaType("hudson bay"); // FROM SAGUENAY:
		    rmSetSeaType("new england coast");
	  // rmEnableLocalWater(false);  // FROM SAGUENAY:
	     rmEnableLocalWater(false);  // FROM PATAGONIA:
	
	  // SET BASE TERRAIN MIX:
	  // rmSetBaseTerrainMix("texas_grass");
	     // rmSetBaseTerrainMix("saguenay tundra"); // FROM SAGUENAY: // testing
		    rmSetBaseTerrainMix("patagonia_grass"); // FROM PATAGONIA:
		 
	
	  // TERRAIN INITIALIZATION:
	  // rmTerrainInitialize("texas\ground1_tex", 5.0);
	     // rmTerrainInitialize("saguenay\ground1_sag", 5.0); // FROM SAGUENAY:
		    rmTerrainInitialize("patagonia\ground_dirt1_pat", 4.0); // FROM PATAGONIA:
	
	  // SET THE MAP TYPE:
	  // rmSetMapType("texas");
	     // rmSetMapType("saguenay"); // FROM SAGUENAY:
		    rmSetMapType("patagonia"); // FROM PATAGONIA:
	  // rmSetMapType("water"); // FROM SAGUENAY:
         rmSetMapType("water"); // FROM PATAGONIA:	  
	  // rmSetMapType("grass");
	     // rmSetMapType("grass"); // FROM SAGUENAY:
	        rmSetMapType("grass"); // FROM PATAGONIA:
	  //rmSetMapType("land");

	  // CHOOSE THE MERCS:
	  chooseMercs();

	  // THE CORNER CONSTRAINT:
	  rmSetWorldCircleConstraint(true);
/*==================================================================================================================*/
// *************************** DEFINE THE CLASSES: THESE ARE USED LATER FOR CONSTRAINTS: ************************** //
/*==================================================================================================================*/
      int classPlayer=rmDefineClass("player");
      rmDefineClass("startingUnit");
	  rmDefineClass("importantItem");
      rmDefineClass("natives");
	  rmDefineClass("nuggets");
	  rmDefineClass("socketClass");
	  rmDefineClass("classForest");
	  rmDefineClass("classHill");
      rmDefineClass("classPatch");
      rmDefineClass("starting settlement");
      rmDefineClass("classCliff");
	  rmDefineClass("secrets");
	  rmDefineClass("center");
	  rmDefineClass("classCotton");
	  rmDefineClass("socketClass");
      rmDefineClass("canyon");
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.20);
/*================================================================================================================*/   
// ***************************************** DEFINE THE CONSTRAINTS: ******************************************** //
// ************************ THESE ARE USED TO HAVE OBJECTS AND AREAS AVOID EACH OTHER: ************************** //
/*================================================================================================================*/
	  // CREATE A EDGE OF MAP CONSTRAINTS:
	  int edgeConstraint=rmCreateBoxConstraint("edge of map", rmXTilesToFraction(4), rmZTilesToFraction(4), 1.0-rmXTilesToFraction(4), 1.0-rmZTilesToFraction(4));
      int playerEdgeConstraint=rmCreateBoxConstraint("player edge of map", rmXTilesToFraction(8), rmZTilesToFraction(8), 1.0-rmXTilesToFraction(8), 1.0-rmZTilesToFraction(8), 0.01);
      int centerConstraint=rmCreateClassDistanceConstraint("stay away from center", rmClassID("center"), 40.0);
	  	   
      // PLAYER CONSTRAINTS:
      int playerConstraint=rmCreateClassDistanceConstraint("stay away from players", classPlayer, 12.0);
      int shortPlayerConstraint=rmCreateClassDistanceConstraint("stay away from players short", classPlayer, 20.0);
	  int mediumPlayerConstraint=rmCreateClassDistanceConstraint("medium stay away from players", classPlayer, 40.0);  
	  int longPlayerConstraint=rmCreateClassDistanceConstraint("land stays away from players", classPlayer, 70.0);  
	  //int smallMapPlayerConstraint=rmCreateClassDistanceConstraint("stay away from players a lot", classPlayer, 70.0);
	  //int playerConstraintForest=rmCreateClassDistanceConstraint("forests kinda stay away from players", classPlayer, 20.0);
      
      // TC AVOIDANCE:
	  int avoidTC=rmCreateTypeDistanceConstraint("stuff vs TC", "TownCenter", 60.0);
	  int shortAvoidTC=rmCreateTypeDistanceConstraint("stuff less vs TC", "TownCenter", 20.0);
	  int avoidCW=rmCreateTypeDistanceConstraint("stuff vs CW", "CoveredWagon", 60.0);
      
      // TOWNCENTER AVOIDANCE:
	  //int avoidTownCenter=rmCreateTypeDistanceConstraint("avoid Town Center", "townCenter", 25.0);
      //int avoidTownCenterFar=rmCreateTypeDistanceConstraint("avoid Town Center Far", "townCenter", 40.0);
      	  
	  // CARDINAL DIRECTIONS FOR EACH 45 DEGREES: (MADE BY DANY:)
	  int North1ward=rmCreatePieConstraint("north1MapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(0), rmDegreesToRadians(45));
      int North2ward=rmCreatePieConstraint("north2MapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(46), rmDegreesToRadians(90));
      int East1ward=rmCreatePieConstraint("east1MapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(91), rmDegreesToRadians(136));
      int East2ward=rmCreatePieConstraint("east2MapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(137), rmDegreesToRadians(180));
      int South1ward=rmCreatePieConstraint("south1MapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(181), rmDegreesToRadians(226));
      int South2ward=rmCreatePieConstraint("south2MapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(226), rmDegreesToRadians(270));
      int West1ward=rmCreatePieConstraint("west1MapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(271), rmDegreesToRadians(316));
      int West2ward=rmCreatePieConstraint("west2MapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(317), rmDegreesToRadians(360));
   
      // CARDINAL DIRECTIONS FOR NW NE SE SW : (MADE BY DANY:)
	  //int NWward=rmCreatePieConstraint("NWMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(45), rmDegreesToRadians(135));
      //int NEward=rmCreatePieConstraint("NEMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(315), rmDegreesToRadians(44));
      //int SEward=rmCreatePieConstraint("SEMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(136), rmDegreesToRadians(225));
      //int SWward=rmCreatePieConstraint("SWMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(226), rmDegreesToRadians(44));
   
	  // CARDINAL DIRECTIONS FOR EACH 90 DEGREES: (MADE BY DANY:)
      int Northward=rmCreatePieConstraint("northMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(0), rmDegreesToRadians(90));
      int Southward=rmCreatePieConstraint("southMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(180), rmDegreesToRadians(270));
      int Eastward=rmCreatePieConstraint("eastMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(90), rmDegreesToRadians(180));
      int Westward=rmCreatePieConstraint("westMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(270), rmDegreesToRadians(360));
  
	  // CREATE BOX CONSTRAINT: (MADE BY DANY:)
	  int Westconstraint = rmCreateBoxConstraint("stay in East Box", 0, 1.0, 0.4, 0.6); 
	  int Eastconstraint = rmCreateBoxConstraint("stay in West Box", 1.0, 0.0, 0.6, 0.4); 
	   
	  // HCGP AVOIDANCE:
	  //int flagConstraint=rmCreateHCGPConstraint("flags avoid same", 20.0);
      int nearWater10 = rmCreateTerrainDistanceConstraint("near water", "Water", true, 10.0);
	  
	  // CONSTRAINT TO AVOID WATER:
      int ferryOnShore=rmCreateTerrainMaxDistanceConstraint("ferry v. water", "water", true, 12.0);
      	  
	  // CONSTRAINT TO AVOID WATER:
      int avoidWater4 = rmCreateTerrainDistanceConstraint("avoid water", "Land", false, 4.0);
      int avoidWater8 = rmCreateTerrainDistanceConstraint("avoid water short", "Land", false, 8.0);
      int avoidWater10 = rmCreateTerrainDistanceConstraint("avoid water medium", "Land", false, 10.0);
      int avoidWater16 = rmCreateTerrainDistanceConstraint("avoid water medium", "Land", false, 16.0);
	  int avoidWater20 = rmCreateTerrainDistanceConstraint("avoid water long", "Land", false, 20.0);
 	   
	  // SHIPS VS. SHIPS:
      int shipVsShip=rmCreateTypeDistanceConstraint("ships avoid ship", "ship", 5.0);
	   
	  // FISH AND WHALE AVOIDANCE:
	  int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "abstractFish", 10.0);
      int whaleVsWhaleID=rmCreateTypeDistanceConstraint("whale v whale", "humpbackWhale", 25.0);
      int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 6.0);
      int whaleLand = rmCreateTerrainDistanceConstraint("whale v. land", "land", true, 20.0);
	  
	  // HOMECITYWATERSPAWNFLAG AVOIDANCE:
	  int flagVsFlag = rmCreateTypeDistanceConstraint("flag avoid same", "HomeCityWaterSpawnFlag", 20);
	  int flagEdgeConstraint = rmCreatePieConstraint("flags stay near edge of map", 0.5, 0.5, rmGetMapXSize()-20, rmGetMapXSize()-10, 0, 0, 0);
      	  
	  // RESOURCES AVOIDANCE:
	  //int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "fish", 18.0);
      //int whaleVsWhaleID=rmCreateTypeDistanceConstraint("whale v whale", "beluga", 15.0);
      //int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 6.0);
      //int whaleLand = rmCreateTerrainDistanceConstraint("whale v. land", "land", true, 15.0);
     
	  // START RESOURCE AVOIDANCE:
	  int cottonConstraint=rmCreateClassDistanceConstraint("cotton constraint", rmClassID("classCotton"), 30.0);
	  int avoidStartResource=rmCreateTypeDistanceConstraint("start resource no overlap", "resource", 1.0);
	 
	  // DECORATION AVOIDANCE:
      int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 8.0);
	  
	  // TRADE ROUTE AND SOCKET AVOIDANCE:
      int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 8.0);
      int avoidTradeRouteFar = rmCreateTradeRouteDistanceConstraint("trade route far", 15.0);
	  int avoidSocket=rmCreateClassDistanceConstraint("avoid sockets", rmClassID("socketClass"), 5.0);
	  int avoidTradeRouteCliff = rmCreateTradeRouteDistanceConstraint("trade route cliff", 10.0);
	  	

	  // IMPORTANT ITEM AVOIDANCE:
	  int avoidImportantItem=rmCreateClassDistanceConstraint("secrets etc avoid each other", rmClassID("importantItem"), 30.0);
      int avoidImportantItemSmall=rmCreateClassDistanceConstraint("important item small avoidance", rmClassID("importantItem"), 10.0);
   
	  // NATIVES AVOIDANCE:
	  int avoidNatives=rmCreateClassDistanceConstraint("stuff avoids natives", rmClassID("natives"), 10.0);
      int nativesAvoidNatives=rmCreateTypeDistanceConstraint("natives avoid natives", "Natives", 25.0);	  
	   
	  // FOREST AVOIDANCE:
	  int forestObjConstraint=rmCreateTypeDistanceConstraint("forest obj", "all", 6.0);
	  int forestConstraint=rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), 12.0);
	  int forestAvoidForest=rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), 18.0);
	  
	  // RESOURCE AVOIDANCE:
	  int avoidResource=rmCreateTypeDistanceConstraint("resource avoid resource", "resource", 20.0);
	
      // STARTING UNITS AVOIDANCE:
      int avoidStartingUnits=rmCreateClassDistanceConstraint("objects avoid starting units", rmClassID("startingUnit"), 30.0);
      int avoidStartingUnitsSmall=rmCreateClassDistanceConstraint("objects avoid starting units small", rmClassID("startingUnit"), 5.0);
      int avoidStartingUnitsLarge=rmCreateClassDistanceConstraint("objects avoid starting units large", rmClassID("startingUnit"), 50.0);
  	  
	  // AVOID IMPASSABLE LAND:
      int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "land", false, 8.0);
      int shortAvoidImpassableLand=rmCreateTerrainDistanceConstraint("short avoid impassable land", "land", false, 2.0);
      int mediumAvoidImpassableLand=rmCreateTerrainDistanceConstraint("medium avoid impassable land", "land", false, 6.0);
	  int longAvoidImpassableLand=rmCreateTerrainDistanceConstraint("long avoid impassable land", "land", false, 10.0);
      
      // HILL AVOIDANCE:
	  int hillConstraint=rmCreateClassDistanceConstraint("hill vs. hill", rmClassID("classHill"), 10.0);
      int shortHillConstraint=rmCreateClassDistanceConstraint("patches vs. hill", rmClassID("classHill"), 5.0);
      
	  // PATCH AVOIDANCE:
	  int patchConstraint=rmCreateClassDistanceConstraint("patch vs. patch", rmClassID("classPatch"), 5.0);
	  	  
	  // CLIFFS AVOIDANCE:
	  int avoidCliffs=rmCreateClassDistanceConstraint("stuff vs. cliff", rmClassID("classCliff"), 8.0);
	  int cliffsAvoidCliffs=rmCreateClassDistanceConstraint("cliffs vs. cliffs", rmClassID("classCliff"), 30.0);
 
	  // CIRCLE CONSTRAINT:
	  int circleConstraint=rmCreatePieConstraint("circle Constraint", 0.5, 0.5, 0, rmZFractionToMeters(0.47), rmDegreesToRadians(0), rmDegreesToRadians(360));
	  
	  // SECRETS AVOIDANCE:
	  int avoidSecrets=rmCreateClassDistanceConstraint("stuff avoids secrets", rmClassID("secrets"), 20.0);
	  	  
	  // COW AVOIDANCE:
      int avoidCow=rmCreateTypeDistanceConstraint("avoid cow", "cow", 8.0);
      int cowAvoidCow=rmCreateTypeDistanceConstraint("cow avoid cow", "cow", 16.0);
	   
	  // SHEEP AVOIDANCE:
	  int avoidSheep=rmCreateTypeDistanceConstraint("sheep avoids sheep", "sheep", 8.0);
	  int sheepAvoidSheep=rmCreateTypeDistanceConstraint("sheep avoid sheep", "sheep", 16.0); 
	  
	  // MUSKOX AVOIDANCE:
      int avoidMuskOx=rmCreateTypeDistanceConstraint("avoid muskOx", "muskOx", 8.0);
      int muskOxAvoidMuskOx=rmCreateTypeDistanceConstraint("muskOx avoid muskOx", "muskOx", 16.0);
	  
	  // NUGGET AVOIDANCE:
	  int avoidNugget=rmCreateClassDistanceConstraint("stuff avoids nugget", rmClassID("nuggets"), 8.0);
	  int avoidNuggetClose=rmCreateClassDistanceConstraint("stuff avoids nugget close", rmClassID("nuggets"), 2.0);
      int nuggetAvoidNugget=rmCreateClassDistanceConstraint("nugget vs. nugget", rmClassID("nuggets"), 40.0);
	  
	  // DEER AVOIDANCE:
      int avoidDeer=rmCreateTypeDistanceConstraint("avoid deer", "deer", 8.0);
      int deerAvoidDeer=rmCreateTypeDistanceConstraint("deer avoid deer", "deer", 16.0); 
      
	  // PRONGHORN AVOIDANCE:
	  int avoidPronghorn=rmCreateTypeDistanceConstraint("avoid pronghorn", "pronghorn", 8.0);
      int pronghornAvoidPronghorn=rmCreateTypeDistanceConstraint("pronghorn avoid pronghorn", "pronghorn", 16.0); 
	  
      // GOLD AVOIDANCE:
      int avoidGold=rmCreateTypeDistanceConstraint("avoid gold", "Gold", 8.0);
	  int avoidGoldClose=rmCreateTypeDistanceConstraint("avoid gold close", "Gold", 2.0);
      int goldAvoidGold=rmCreateTypeDistanceConstraint("gold avoid gold", "Gold", 16.0);
	  
	  // SILVER AVOIDANCE:
      int avoidCoin=rmCreateTypeDistanceConstraint("avoid coin", "mine", 8.0);
      int coinAvoidCoin=rmCreateTypeDistanceConstraint("coin avoid coin", "mine", 16.0);
	  int avoidCoinFar=rmCreateTypeDistanceConstraint("avoid coin far", "mine", 55.0);
	  
	  // COIN AVOIDANCE:
	  //int avoidCoin=rmCreateTypeDistanceConstraint("avoid coin", "gold", 40.0);
	  //int coinAvoidCoin=rmCreateTypeDistanceConstraint("coin avoid coin", "gold", 16.0);
	  //int avoidCoinFar=rmCreateTypeDistanceConstraint("avoid coin far", "gold", 55.0);
	   
	  // CARIBOU AVOIDANCE:
	  int avoidCaribou=rmCreateTypeDistanceConstraint("avoid caribou", "caribou", 8.0);
      int caribouAvoidCaribou=rmCreateTypeDistanceConstraint("caribou avoid caribou", "caribou", 16.0);
	  
	  // BERRYBUSH AVOIDANCE:
      int avoidBerries=rmCreateTypeDistanceConstraint("avoid berrybush", "berrybush", 8.0);
      int berriesAvoidBerries=rmCreateTypeDistanceConstraint("berrybush avoid berrybush", "berrybush", 16.0);
	
	  // FRUITS (BERRYBUSH) AVOIDANCE:
      int avoidFruits=rmCreateTypeDistanceConstraint("avoid fruits", "berrybush", 8.0);
      int fruitsAvoidFruits=rmCreateTypeDistanceConstraint("fruits avoid fruits", "berrybush", 25.0);
	
      // MOOSE AVOIDANCE:
      int avoidMoose=rmCreateTypeDistanceConstraint("avoid the moose", "moose", 10.0);
      int mooseAvoidMoose=rmCreateTypeDistanceConstraint("moose avoid moose", "Moose", 25.0);
	  
	  // BISON AVOIDANCE:
      int avoidBison=rmCreateTypeDistanceConstraint("avoid the bison", "bison", 10.0);
      int bisonAvoidBison=rmCreateTypeDistanceConstraint("bison avoid bison", "Bison", 25.0);

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.25);
/*================================================================================================================*/
// ************************************* DEFINE THE PLAYER LOCATIONS: ******************************************* //
/*================================================================================================================*/
   	if ( cNumberTeams == 2 )
/*----------------------------------------------------------------------------------------------------------------*/	
	{
		rmSetPlacementTeam(0);
		rmSetPlacementSection(0.15, 0.35);
		if (cNumberNonGaiaPlayers >6)
		{
			rmSetPlacementSection(0.13, 0.37);
		}
		rmPlacePlayersCircular(0.35, 0.40, 0.0);
		   

		rmSetPlacementTeam(1);
		rmSetPlacementSection(0.65, 0.85);
		if (cNumberNonGaiaPlayers >6)
		{
			rmSetPlacementSection(0.63, 0.87);
		}
		rmPlacePlayersCircular(0.35, 0.40, 0.0);
		   
	}
/*----------------------------------------------------------------------------------------------------------------*/	
	else
/*----------------------------------------------------------------------------------------------------------------*/	
	{
  		rmSetPlacementSection(0.0, 0.95);
		rmPlacePlayersCircular(0.40, 0.42, 0.0);
	}
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.30);
/*================================================================================================================*/
// *********************************** DEFINE AND PLACE THE TRADE ROUTE 1: ************************************** //
/*================================================================================================================*/
      int tradeRoute = rmCreateTradeRoute();
	  int socket = rmCreateObjectDef("Sockets for Trade Route 1");
/*----------------------------------------------------------------------------------------------------------------*/
      rmSetObjectDefTradeRouteID(socket, tradeRoute);
      rmAddObjectDefItem(socket, "socketTradeRoute", 1, 0.0);
      rmSetObjectDefAllowOverlap(socket, true);
      rmSetObjectDefMinDistance(socket, 0.0);
      rmSetObjectDefMaxDistance(socket, 8.0);
/*================================================================================================================*/	  
// ******************** ADD WAYPOINTS FOR THE ROUTE - STARTS IN THE NORTH AND GOES SOUTH: *********************** //
/*================================================================================================================*/
      //rmAddTradeRouteWaypoint(tradeRoute, 0.85, 0.95);//dont touch...
        //rmAddTradeRouteWaypoint(tradeRoute, 0.9, 0.9);
		  rmAddTradeRouteWaypoint(tradeRoute, 0.75, 0.9);
	  
	    //rmAddTradeRouteWaypoint(tradeRoute, 0.75, 0.9);
        //rmAddTradeRouteWaypoint(tradeRoute, 0.60, 0.75);
		  rmAddTradeRouteWaypoint(tradeRoute, 0.60, 0.875);
        //rmAddTradeRouteWaypoint(tradeRoute, 0.45, 0.75);
        //rmAddTradeRouteWaypoint(tradeRoute, 0.30, 0.9);
      
	  //rmAddTradeRouteWaypoint(tradeRoute, 0.85, 0.05);//dont touch...
	    //rmAddTradeRouteWaypoint(tradeRoute, 0.1, 0.9);
		  rmAddTradeRouteWaypoint(tradeRoute, 0.24, 0.9);
/*----------------------------------------------------------------------------------------------------------------*/
      bool placedTradeRoute = rmBuildTradeRoute(tradeRoute, "dirt");
      if(placedTradeRoute == false)
      rmEchoError("Failed to place trade route"); 
/*================================================================================================================*/
// *********************** PLACE THE SOCKETS ALONG THE TRADE ROUTE - USES PERCENTAGES: ************************** //
/*================================================================================================================*/
      vector socketLoc = rmGetTradeRouteWayPoint(tradeRoute, 0.05);
      rmPlaceObjectDefAtPoint(socket, 0, socketLoc);
	  socketLoc = rmGetTradeRouteWayPoint(tradeRoute, 0.35);
      rmPlaceObjectDefAtPoint(socket, 0, socketLoc);
      socketLoc = rmGetTradeRouteWayPoint(tradeRoute, 0.65);
      rmPlaceObjectDefAtPoint(socket, 0, socketLoc);
      socketLoc = rmGetTradeRouteWayPoint(tradeRoute, 0.95);
      rmPlaceObjectDefAtPoint(socket, 0, socketLoc);
/*================================================================================================================*/
// *********************************** DEFINE AND PLACE THE TRADE ROUTE 2: ************************************** //
/*================================================================================================================*/
      int tradeRoute2 = rmCreateTradeRoute();
      int socket2 = rmCreateObjectDef("Sockets for Trade Route 2"); 
/*----------------------------------------------------------------------------------------------------------------*/
      rmSetObjectDefTradeRouteID(socket2, tradeRoute2);
      rmAddObjectDefItem(socket2, "socketTradeRoute2", 1, 0.0);
      rmSetObjectDefAllowOverlap(socket2, true);
      rmSetObjectDefMinDistance(socket2, 0.0);
      rmSetObjectDefMaxDistance(socket2, 8.0);
/*================================================================================================================*/	  
// ******************** ADD WAYPOINTS FOR THE ROUTE - STARTS IN THE NORTH AND GOES SOUTH: *********************** //
/*================================================================================================================*/
	  //rmAddTradeRouteWaypoint(tradeRoute2, 0.1, 0.125);
	    rmAddTradeRouteWaypoint(tradeRoute2, 0.20, 0.125);
	  
	  //rmAddTradeRouteWaypoint(tradeRoute2, 0.3, 0.140);
      //rmAddTradeRouteWaypoint(tradeRoute2, 0.5, 0.250);
	    rmAddTradeRouteWaypoint(tradeRoute2, 0.5, 0.150);
      //rmAddTradeRouteWaypoint(tradeRoute2, 0.6, 0.250);
      //rmAddTradeRouteWaypoint(tradeRoute2, 0.8, 0.140);
	  
	  //rmAddTradeRouteWaypoint(tradeRoute2, 0.9, 0.1);
	    rmAddTradeRouteWaypoint(tradeRoute2, 0.8, 0.125);
/*----------------------------------------------------------------------------------------------------------------*/	  
	  bool placedTradeRoute2 = rmBuildTradeRoute(tradeRoute2, "dirt");
      if(placedTradeRoute2 == false)
      rmEchoError("Failed to place trade route");
/*================================================================================================================*/
// *********************** PLACE THE SOCKETS ALONG THE TRADE ROUTE - USES PERCENTAGES: ************************** //
/*================================================================================================================*/
      vector socket2Loc = rmGetTradeRouteWayPoint(tradeRoute2, 0.05);
      rmPlaceObjectDefAtPoint(socket, 0, socket2Loc);
	  socket2Loc = rmGetTradeRouteWayPoint(tradeRoute2, 0.38);
      rmPlaceObjectDefAtPoint(socket, 0, socket2Loc);
	  socket2Loc = rmGetTradeRouteWayPoint(tradeRoute2, 0.65);
      rmPlaceObjectDefAtPoint(socket, 0, socket2Loc);
	  socket2Loc = rmGetTradeRouteWayPoint(tradeRoute2, 0.95);
      rmPlaceObjectDefAtPoint(socket, 0, socket2Loc);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.32);
/*================================================================================================================*/
// ************************************* DEFINE THE SET UP PLAYER AREAS: **************************************** //
/*================================================================================================================*/
      float playerFraction=rmAreaTilesToFraction(100);
/*----------------------------------------------------------------------------------------------------------------*/	  
      for(i=1; <cNumberPlayers)
/*----------------------------------------------------------------------------------------------------------------*/	  
   {
/*----------------------------------------------------------------------------------------------------------------*/   
      // CREATE THE AREA.
      int id=rmCreateArea("Player"+i);
      
	  // ASSIGN TO THE PLAYER:
      rmSetPlayerArea(i, id);
      
	  // SET THE SIZE:
      rmSetAreaSize(id, playerFraction, playerFraction);
      
	  // ADD AREA TO CLASS:
	  rmAddAreaToClass(id, classPlayer);
      
	  // SET AREA MIN AND MAX BLOBS:
	  rmSetAreaMinBlobs(id, 1);
      rmSetAreaMaxBlobs(id, 1);
      
	  // ADD AREA CONSTRAINT:
	  rmAddAreaConstraint(id, playerConstraint); 
      //rmAddAreaConstraint(id, playerEdgeConstraint); 
      
	  // SET AREA LOC PLAYER:
	  rmSetAreaLocPlayer(id, i);
	  
	  // SET AREA TERRAIN TYPE:
	  // rmSetAreaTerrainType(id, "texas\ground2");
	     // rmSetAreaTerrainType(id, "saguenay\ground5_sag");
	        // rmSetAreaTerrainType(id, "saguenay\ground1_sag"); // testing
			   rmSetAreaTerrainType(id, "patagonia\ground_dirt1_pat");
      
	  // SET AREA WARN FAILURE:
	  rmSetAreaWarnFailure(id, false);
/*----------------------------------------------------------------------------------------------------------------*/	  
   }
/*----------------------------------------------------------------------------------------------------------------*/   
      // BUILD THE AREAS:
      rmBuildAllAreas();
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.33);
/*================================================================================================================*/   
// ********************************** DEFINE AND PLACE THE NATIVES TRIBES: ************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
    	if (subCiv0 == rmGetCivID("maya")) // SW TRIBES:
/*----------------------------------------------------------------------------------------------------------------*/		
	{  
		int mayaVillage1ID = -1;
		mayaVillage1ID = rmCreateGrouping("maya village 1", "native maya village 1");
		rmSetGroupingMinDistance(mayaVillage1ID, 0.0);
		//rmSetGroupingMaxDistance(mayaVillage1ID, rmXFractionToMeters(0.5));
		  rmSetGroupingMaxDistance(mayaVillage1ID, 0.0);
		rmAddGroupingToClass(mayaVillage1ID, rmClassID("natives"));
		rmAddGroupingConstraint(mayaVillage1ID, avoidNatives);
		//rmPlaceGroupingAtLoc(mayaVillage1ID, 0, 0.5, 0.5);
		  rmPlaceGroupingAtLoc(mayaVillage1ID, 0, 0.10, 0.40);
	} 
/*----------------------------------------------------------------------------------------------------------------*/
		if (subCiv1 == rmGetCivID("maya")) // NW TRIBES:
/*----------------------------------------------------------------------------------------------------------------*/		
	{  
		int mayaVillage2ID = -1;
		mayaVillage2ID = rmCreateGrouping("maya village 2", "native maya village 1");
		rmSetGroupingMinDistance(mayaVillage2ID, 0.0);
		//rmSetGroupingMaxDistance(mayaVillage2ID, rmXFractionToMeters(0.5));
		  rmSetGroupingMaxDistance(mayaVillage2ID, 0.0);
		rmAddGroupingToClass(mayaVillage2ID, rmClassID("natives"));
		rmAddGroupingConstraint(mayaVillage2ID, avoidNatives);
		//rmPlaceGroupingAtLoc(mayaVillage2ID, 0, 0.5, 0.5);
		rmPlaceGroupingAtLoc(mayaVillage2ID, 0, 0.20, 0.82);
	} 
/*----------------------------------------------------------------------------------------------------------------*/
		if (subCiv2 == rmGetCivID("maya")) // SE TRIBES:
/*----------------------------------------------------------------------------------------------------------------*/		
	{  
		int mayaVillage3ID = -1;
		mayaVillage3ID = rmCreateGrouping("maya village 3", "native maya village 1");
		rmSetGroupingMinDistance(mayaVillage3ID, 0.0);
		//rmSetGroupingMaxDistance(mayaVillage3ID, rmXFractionToMeters(0.5));
		rmSetGroupingMaxDistance(mayaVillage3ID, 0.0);
		rmAddGroupingToClass(mayaVillage3ID, rmClassID("natives"));
		rmAddGroupingConstraint(mayaVillage3ID, avoidNatives);
		//rmPlaceGroupingAtLoc(mayaVillage3ID, 0, 0.5, 0.5);
		rmPlaceGroupingAtLoc(mayaVillage3ID, 0, 0.70, 0.22);
	} 
/*----------------------------------------------------------------------------------------------------------------*/
		if (subCiv3 == rmGetCivID("maya")) // NE TRIBES:
/*----------------------------------------------------------------------------------------------------------------*/		
	{  
		int mayaVillage4ID = -1;
		mayaVillage4ID = rmCreateGrouping("maya village 4", "native maya village 1");
		rmSetGroupingMinDistance(mayaVillage4ID, 0.0);
		//rmSetGroupingMaxDistance(mayaVillage4ID, rmXFractionToMeters(0.5));
		rmSetGroupingMaxDistance(mayaVillage4ID, 0.0);
		rmAddGroupingToClass(mayaVillage4ID, rmClassID("natives"));
		rmAddGroupingConstraint(mayaVillage4ID, avoidNatives);
		//rmPlaceGroupingAtLoc(mayaVillage4ID, 0, 0.5, 0.5);
		rmPlaceGroupingAtLoc(mayaVillage4ID, 0, 0.93, 0.60);
	}
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.34);
/*================================================================================================================*/
// ******************************* DEFINE THE TCID AND THE STARTING UNITS: ************************************** //
/*================================================================================================================*/
	int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
    rmSetObjectDefMinDistance(startingUnits, 5.0);
    rmSetObjectDefMaxDistance(startingUnits, 10.0);
	//rmAddObjectDefConstraint(startingUnits, avoidAll);

	int startingTCID= rmCreateObjectDef("startingTC");
	if ( rmGetNomadStart())
	{
		rmAddObjectDefItem(startingTCID, "CoveredWagon", 1, 0.0);
	}
	else
	{
		rmAddObjectDefItem(startingTCID, "TownCenter", 1, 0.0);
		// Give it a little wiggle room for maps with greater than four players
		if ( cNumberNonGaiaPlayers > 4 )
		{
			rmSetObjectDefMinDistance(startingTCID, 0.0);
			rmSetObjectDefMaxDistance(startingTCID, 6.0);
		}
	}
/*================================================================================================================*/
// ********************************** DEFINE THE STARTING RESOURCES: ******************************************** //
/*================================================================================================================*/
      // DEFINE THE STARTING TREES:
	  int StartAreaTreeID=rmCreateObjectDef("starting trees");
	  //rmAddObjectDefItem(StartAreaTreeID, "TreeTexasDirt", 1, 0.0);
	  rmAddObjectDefItem(StartAreaTreeID, "TreePatagoniaDirt", 1, 0.0);
	  rmSetObjectDefMinDistance(StartAreaTreeID, 8);
	  rmSetObjectDefMaxDistance(StartAreaTreeID, 14);
	  rmAddObjectDefConstraint(StartAreaTreeID, avoidStartResource);
	  	
	  // DEFINE THE STARTING PRONGHORNS:
	  int StartPronghornID=rmCreateObjectDef("starting pronghorn");
	  rmAddObjectDefItem(StartPronghornID, "pronghorn", 4, 4.0);
	  rmSetObjectDefMinDistance(StartPronghornID, 5);
	  rmSetObjectDefMaxDistance(StartPronghornID, 12);
	  rmAddObjectDefConstraint(StartPronghornID, avoidStartResource);
	  rmSetObjectDefCreateHerd(StartPronghornID, true);
	
	  // DEFINE THE STARTING BERRYBUSH:
	  int StartBerryBushID=rmCreateObjectDef("starting berry bush 1");
	  rmAddObjectDefItem(StartBerryBushID, "BerryBush", 3, 4.0);
	  rmSetObjectDefMinDistance(StartBerryBushID, 12.0);
	  rmSetObjectDefMaxDistance(StartBerryBushID, 16.0);
	  rmAddObjectDefConstraint(StartBerryBushID, avoidStartingUnitsSmall);
	  
	  // DEFINE THE STARTING BERRYBUSH FAR:
	  int StartBerryBushFarID=rmCreateObjectDef("starting berry bush 2");
	  rmAddObjectDefItem(StartBerryBushFarID, "BerryBush", 3, 4.0);
	  rmSetObjectDefMinDistance(StartBerryBushFarID, 18.0);
	  rmSetObjectDefMaxDistance(StartBerryBushFarID, 24.0);
	  rmAddObjectDefConstraint(StartBerryBushFarID, avoidStartingUnitsSmall);
	
	  // DEFINE THE PLAYER BISONS:
	  int playerBisonID=rmCreateObjectDef("player bison herd");
      rmAddObjectDefItem(playerBisonID, "bison", rmRandInt(6,8), 6.0);
      rmSetObjectDefMinDistance(playerBisonID, 20.0);
      rmSetObjectDefMaxDistance(playerBisonID, 25.0);
	  rmSetObjectDefCreateHerd(playerBisonID, true);
	  
	  // DEFINE THE NUGGETS:
	  int playerNuggetID=rmCreateObjectDef("player nugget");
	  rmAddObjectDefItem(playerNuggetID, "nugget", 1, 0.0);
	  rmAddObjectDefToClass(playerNuggetID, rmClassID("nuggets"));
      rmSetObjectDefMinDistance(playerNuggetID, 30.0);
      rmSetObjectDefMaxDistance(playerNuggetID, 35.0);
	  rmAddObjectDefConstraint(playerNuggetID, avoidNugget);
	  rmAddObjectDefConstraint(playerNuggetID, circleConstraint);
	  
	  // DEFINE THE SILVER MINES:
	  int playerGoldID=rmCreateObjectDef("player silver ore");
	  int silverType = rmRandInt(1,10);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.35);
/*================================================================================================================*/
// ********************************* PLACE THE TCID AND THE STARTING UNITS: ************************************* //
/*================================================================================================================*/
	    for(i=1; <cNumberPlayers)
	{
		// PLACE THE STARTING UNITS AND A TC:
		rmPlaceObjectDefAtLoc(startingTCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(startingUnits, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
	    // PLACE THE STARTING TREES:
    	rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		// PLACE THE STARTING PRONGHORN:
		rmPlaceObjectDefAtLoc(StartPronghornID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		// PLACE THE STARTING BERRYBUSH:
		rmPlaceObjectDefAtLoc(StartBerryBushID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartBerryBushFarID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		// EVERYONE GETS TWO BISON HERDS:
		rmPlaceObjectDefAtLoc(playerBisonID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		//rmPlaceObjectDefAtLoc(playerBisonID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		// PLACE THE PLAYER NUGGETS:
		rmSetNuggetDifficulty(1, 1);
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		// EVERYONE GETS TWO ORE GROUPINGS, ONE PRETTY CLOSE, THE OTHER A LITTLE FURTHER AWAY:
		silverType = rmRandInt(1,10);
		playerGoldID = rmCreateObjectDef("player silver closer "+i);
		rmAddObjectDefItem(playerGoldID, "mine", 1, 0.0);
		//rmAddObjectDefConstraint(playerGoldID, avoidTradeRoute);
		rmAddObjectDefConstraint(playerGoldID, coinAvoidCoin);
		//rmAddObjectDefConstraint(playerGoldID, avoidCliffs);
		//rmAddObjectDefConstraint(playerGoldID, avoidImportantItemSmall);
		//rmSetObjectDefMinDistance(playerGoldID, 25.0);
		//rmSetObjectDefMaxDistance(playerGoldID, 30.0);
		rmSetObjectDefMinDistance(playerGoldID, 14.0);
		rmSetObjectDefMaxDistance(playerGoldID, 20.0);
		rmPlaceObjectDefAtLoc(playerGoldID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		silverType = rmRandInt(1,10);
		playerGoldID = rmCreateObjectDef("player silver further "+i);
		rmAddObjectDefItem(playerGoldID, "mine", 1, 0.0);
		//rmAddObjectDefConstraint(playerGoldID, avoidTradeRoute);
		rmAddObjectDefConstraint(playerGoldID, coinAvoidCoin);
		//rmAddObjectDefConstraint(playerGoldID, avoidCliffs);
		//rmAddObjectDefConstraint(playerGoldID, avoidImportantItemSmall);
		//rmSetObjectDefMinDistance(playerGoldID, 40.0);
		//rmSetObjectDefMaxDistance(playerGoldID, 50.0);
		rmSetObjectDefMinDistance(playerGoldID, 22.0);
		rmSetObjectDefMaxDistance(playerGoldID, 28.0);
		rmPlaceObjectDefAtLoc(playerGoldID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		vector closestPoint=rmGetUnitPosition(rmGetUnitPlacedOfPlayer(startingUnits, i));
	}
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.40);
/*================================================================================================================*/   
// ****************************************** MOUNTAIN IN THE CENTER ******************************************** //
/*================================================================================================================*/   
		  int smallCliffHeight=rmRandInt(0,10);
		  //int smallMesaID=rmCreateArea("small mesa"+i);
		  int smallMesaID=rmCreateArea("small mesa"+i);
          rmSetAreaSize(smallMesaID, rmAreaTilesToFraction(9500), rmAreaTilesToFraction(9500)); 
		  rmSetAreaWarnFailure(smallMesaID, false);
		  //rmSetAreaCliffType(smallMesaID, "Caribbean");
		    //rmSetAreaCliffType(smallMesaID, "New England"); //testing
			rmSetAreaCliffType(smallMesaID, "Patagonia"); // FROM PATAGONIA:
			//rmSetAreaMix(smallMesaID, "saguenay grass"); // FROM SAGUENAY:
			rmSetAreaMix(smallMesaID, "patagonia_dirt"); // FROM PATAGONIA:
		  rmAddAreaToClass(smallMesaID, rmClassID("canyon"));	// Attempt to keep cliffs away from each other.
		  //rmSetAreaCliffEdge(smallMesaID, 1, 1.0, 0.1, 1.0, 0);
		  //rmSetAreaCliffEdge(smallMesaID, 2, 0.4, 0.1, 1.0, 0);
		    rmSetAreaCliffEdge(smallMesaID, 2, 0.4, 0.1, 1.0, 2);
		  //rmSetAreaCliffHeight(smallMesaID, rmRandInt(6, 8), 1.0, 1.0);  //was rmRandInt(6, 8)
		    rmSetAreaCliffHeight(smallMesaID, 8, 1.0, 1.0);  //was rmRandInt(6, 8)
		  rmSetAreaCoherence(smallMesaID, 0.88);
		  //rmSetAreaLocation(smallMesaID, 0.55, 0.39); 
		    rmSetAreaLocation(smallMesaID, 0.50, 0.50); 
		  //rmAddAreaInfluenceSegment(smallMesaID, 0.48, 0.43, 0.5, 0.40);  //Bottom - Original segment
		  //rmAddAreaInfluenceSegment(smallMesaID, 0.46, 0.40, 0.53, 0.38); //Right
		  //rmAddAreaInfluenceSegment(smallMesaID, 0.53, 0.45, 0.53, 0.38); //Top - Original segment
		  //rmAddAreaInfluenceSegment(smallMesaID, 0.53, 0.45, 0.48, 0.43); //Left
		  rmBuildArea(smallMesaID);
/*----------------------------------------------------------------------------------------------------------------*/          
	      // Special AREA CONSTRAINTS and use it to make resources avoid the mountain in center:
		  int smallMesaConstraint = rmCreateAreaDistanceConstraint("avoid Small Mesa", smallMesaID, 4.0);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.45);
/*================================================================================================================*/   
// ************************************ LET'S TRY PONDS INSTEAD OF CLIFFS: ************************************** //
/*================================================================================================================*/
	  int pondClass=rmDefineClass("pond");
      int pondConstraint=rmCreateClassDistanceConstraint("ponds avoid ponds", rmClassID("pond"), 10.0);
/*----------------------------------------------------------------------------------------------------------------*/
      int numPonds=cNumberNonGaiaPlayers;
/*----------------------------------------------------------------------------------------------------------------*/	  
	  for(i=0; <numPonds)
/*----------------------------------------------------------------------------------------------------------------*/	  
   {
/*----------------------------------------------------------------------------------------------------------------*/   
      int smallPondID=rmCreateArea("small pond");
      rmSetAreaSize(smallPondID, rmAreaTilesToFraction(2250), rmAreaTilesToFraction(2250));
      //rmSetAreaWaterType(smallPondID, "new england lake");
	    rmSetAreaWaterType(smallPondID, "hudson bay");
	  rmSetAreaBaseHeight(smallPondID, 8);
      rmAddAreaToClass(smallPondID, pondClass);
      rmSetAreaCoherence(smallPondID, 0.4);
      rmSetAreaSmoothDistance(smallPondID, 5);
      rmAddAreaConstraint(smallPondID, pondConstraint);
      rmSetAreaWarnFailure(smallPondID, false);
/*----------------------------------------------------------------------------------------------------------------*/	  
	  rmSetAreaLocation(smallPondID, 0.5, 0.5); 
      rmBuildArea(smallPondID);
/*----------------------------------------------------------------------------------------------------------------*/	  
   }
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.50);
/*================================================================================================================*/   
// ************************************ DEFINE AND PLACE THE GOLD MINES 1: ************************************** //
/*================================================================================================================*/	
      int Ore1ID=rmCreateObjectDef("Gold Mine 1");
      rmAddObjectDefItem(Ore1ID, "minegold", 1, 0.0);
        //rmAddObjectDefItem(Ore1ID, "minegold", 1, 6.0);
	  rmSetObjectDefMinDistance(Ore1ID, 0.0);
      //rmSetObjectDefMaxDistance(Ore1ID, rmXFractionToMeters(0.5));	
	    rmSetObjectDefMaxDistance(Ore1ID, 0.0);	
      //rmAddObjectDefConstraint(Ore1ID, avoidGold);
	  rmPlaceObjectDefAtLoc(Ore1ID, 0, 0.80, 0.20, 1);
/*================================================================================================================*/
// ********************************* DEFINE AND PLACE THE GOLD MINE NUMBER 2: *********************************** //
/*================================================================================================================*/
      int Ore2ID=rmCreateObjectDef("Gold Mine 2");
      rmAddObjectDefItem(Ore2ID, "minegold", 1, 0.0);
        //rmAddObjectDefItem(Ore12D, "minegold", 1, 6.0);
	  rmSetObjectDefMinDistance(Ore2ID, 0.0);
      //rmSetObjectDefMaxDistance(Ore2ID, rmXFractionToMeters(0.5));	
	    rmSetObjectDefMaxDistance(Ore2ID, 0.0);	
      //rmAddObjectDefConstraint(Ore2ID, avoidGold);
	  rmPlaceObjectDefAtLoc(Ore2ID, 0, 0.3, 0.85, 1);	
/*================================================================================================================*/
// ********************************* DEFINE AND PLACE THE GOLD MINE NUMBER 3: *********************************** //
/*================================================================================================================*/
      int Ore3ID=rmCreateObjectDef("Gold Mine 3");
      rmAddObjectDefItem(Ore3ID, "minegold", 1, 0.0);
        //rmAddObjectDefItem(Ore3D, "minegold", 1, 6.0);
	  rmSetObjectDefMinDistance(Ore3ID, 0.0);
      //rmSetObjectDefMaxDistance(Ore3ID, rmXFractionToMeters(0.5));	
	    rmSetObjectDefMaxDistance(Ore3ID, 0.0);	
      //rmAddObjectDefConstraint(Ore3ID, avoidGold);
	  rmPlaceObjectDefAtLoc(Ore3ID, 0, 0.75, 0.85, 1);		  
/*================================================================================================================*/
// ********************************* DEFINE AND PLACE THE GOLD MINE NUMBER 4: *********************************** //
/*================================================================================================================*/
      int Ore4ID=rmCreateObjectDef("Gold Mine 4");
      rmAddObjectDefItem(Ore4ID, "minegold", 1, 0.0);
        //rmAddObjectDefItem(Ore4D, "minegold", 1, 6.0);
	  rmSetObjectDefMinDistance(Ore4ID, 0.0);
      //rmSetObjectDefMaxDistance(Ore4ID, rmXFractionToMeters(0.5));	
	    rmSetObjectDefMaxDistance(Ore4ID, 0.0);	
      //rmAddObjectDefConstraint(Ore4ID, avoidGold);
	  rmPlaceObjectDefAtLoc(Ore4ID, 0, 0.25, 0.2, 1);
/*================================================================================================================*/
// ****************************** DEFINE AND PLACE THE GOLD MINE NUMBER 5: ************************************** //
/*================================================================================================================*/
      int Ore5ID=rmCreateObjectDef("Gold Mine 5");
      rmAddObjectDefItem(Ore5ID, "minegold", 1, 0.0);
        //rmAddObjectDefItem(Ore5D, "minegold", 1, 6.0);
	  rmSetObjectDefMinDistance(Ore5ID, 0.0);
      //rmSetObjectDefMaxDistance(Ore5ID, rmXFractionToMeters(0.5));	
	    rmSetObjectDefMaxDistance(Ore5ID, 0.0);	
      //rmAddObjectDefConstraint(Ore5ID, avoidGold);
	  rmPlaceObjectDefAtLoc(Ore5ID, 0, 0.54, 0.83, 1);
/*================================================================================================================*/
// ********************************************* GOLD MINE NUMBER 6: ******************************************** //
/*================================================================================================================*/
      int Ore6ID=rmCreateObjectDef("Gold Mine 6");
      rmAddObjectDefItem(Ore6ID, "minegold", 1, 0.0);
        //rmAddObjectDefItem(Ore6D, "minegold", 1, 6.0);
	  rmSetObjectDefMinDistance(Ore6ID, 0.0);
      //rmSetObjectDefMaxDistance(Ore6ID, rmXFractionToMeters(0.5));	
	    rmSetObjectDefMaxDistance(Ore6ID, 0.0);	
      //rmAddObjectDefConstraint(Ore6ID, avoidGold);
	  rmPlaceObjectDefAtLoc(Ore6ID, 0, 0.54, 0.20, 1);	
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE GOLD MINE 7: *************************************** //
/*================================================================================================================*/
      int Ore7ID=rmCreateObjectDef("Gold Mine 7");
      rmAddObjectDefItem(Ore7ID, "minegold", 1, 0.0);
        //rmAddObjectDefItem(Ore7D, "minegold", 1, 6.0);
	  rmSetObjectDefMinDistance(Ore7ID, 0.0);
      //rmSetObjectDefMaxDistance(Ore7ID, rmXFractionToMeters(0.5));	
	    rmSetObjectDefMaxDistance(Ore7ID, 0.0);	
      //rmAddObjectDefConstraint(Ore7ID, avoidGold);
	  rmPlaceObjectDefAtLoc(Ore7ID, 0, 0.95, 0.45, 1);	  
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE GOLD MINES 8: ************************************** //
/* ===============================================================================================================*/
      int Ore8ID=rmCreateObjectDef("Gold Mine 8");
      rmAddObjectDefItem(Ore8ID, "minegold", 1, 0.0);
      // rmAddObjectDefItem(Ore8D, "minegold", 1, 6.0);
	  rmSetObjectDefMinDistance(Ore8ID, 0.0);
      // rmSetObjectDefMaxDistance(Ore8ID, rmXFractionToMeters(0.5));	
	     rmSetObjectDefMaxDistance(Ore8ID, 0.0);	
      rmAddObjectDefConstraint(Ore8ID, avoidGold);
	  rmPlaceObjectDefAtLoc(Ore8ID, 0, 0.075, 0.65, 1);	
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE GOLD MINES 9: ************************************** //
/* ===============================================================================================================*/
      int Ore9ID=rmCreateObjectDef("Gold Mine 9");
      rmAddObjectDefItem(Ore9ID, "minegold", 1, 0.0);
      // rmAddObjectDefItem(Ore9D, "minegold", 1, 6.0);
	  rmSetObjectDefMinDistance(Ore9ID, 0.0);
      // rmSetObjectDefMaxDistance(Ore9ID, rmXFractionToMeters(0.5));	
	     rmSetObjectDefMaxDistance(Ore9ID, 0.0);	
      rmAddObjectDefConstraint(Ore9ID, avoidGold);
	  rmPlaceObjectDefAtLoc(Ore9ID, 0, 0.65, 0.60, 1);
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE GOLD MINES 10: ************************************* //
/* ===============================================================================================================*/
      int Ore10ID=rmCreateObjectDef("Gold Mine 10");
      rmAddObjectDefItem(Ore10ID, "minegold", 1, 0.0);
      // rmAddObjectDefItem(Ore10D, "minegold", 1, 6.0);
	  rmSetObjectDefMinDistance(Ore10ID, 0.0);
      // rmSetObjectDefMaxDistance(Ore10ID, rmXFractionToMeters(0.5));	
	     rmSetObjectDefMaxDistance(Ore10ID, 0.0);	
      rmAddObjectDefConstraint(Ore10ID, avoidGold);
	  rmPlaceObjectDefAtLoc(Ore10ID, 0, 0.35, 0.60, 1);	
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE GOLD MINES 11: ************************************* //
/* ===============================================================================================================*/
      int Ore11ID=rmCreateObjectDef("Gold Mine 11");
      rmAddObjectDefItem(Ore11ID, "minegold", 1, 0.0);
      // rmAddObjectDefItem(Ore11D, "minegold", 1, 6.0);
	  rmSetObjectDefMinDistance(Ore11ID, 0.0);
      // rmSetObjectDefMaxDistance(Ore11ID, rmXFractionToMeters(0.5));	
	     rmSetObjectDefMaxDistance(Ore11ID, 0.0);	
      rmAddObjectDefConstraint(Ore11ID, avoidGold);
	  rmPlaceObjectDefAtLoc(Ore11ID, 0, 0.325, 0.40, 1);
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE GOLD MINES 12: ************************************* //
/* ===============================================================================================================*/
      int Ore12ID=rmCreateObjectDef("Gold Mine 12");
      rmAddObjectDefItem(Ore12ID, "minegold", 1, 0.0);
      // rmAddObjectDefItem(Ore12D, "minegold", 1, 6.0);
	  rmSetObjectDefMinDistance(Ore12ID, 0.0);
      // rmSetObjectDefMaxDistance(Ore12ID, rmXFractionToMeters(0.5));	
	     rmSetObjectDefMaxDistance(Ore12ID, 0.0);	
      rmAddObjectDefConstraint(Ore12ID, avoidGold);
	  rmPlaceObjectDefAtLoc(Ore12ID, 0, 0.55, 0.30, 1);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.55);
/*================================================================================================================*/   
// ********************************* DEFINE AND PLACE THE RANDOM TREE 1: **************************************** //
/*================================================================================================================*/
      int randomTreeID=rmCreateObjectDef("random tree 1");
      // rmAddObjectDefItem(randomTreeID, "TreePatagoniaDirt", 1, 0.0);
         rmAddObjectDefItem(randomTreeID, "TreePatagoniaDirt", rmRandInt(7,12), 6.0);
      rmSetObjectDefMinDistance(randomTreeID, 0.0);
      // rmSetObjectDefMaxDistance(randomTreeID, rmXFractionToMeters(0.5));
         rmSetObjectDefMaxDistance(randomTreeID, 0.0);
      rmAddObjectDefConstraint(randomTreeID, rmCreateTypeDistanceConstraint("random tree", "all", 2.0));
      //rmAddObjectDefConstraint(randomTreeID, shortAvoidImpassableLand);
      //rmAddObjectDefConstraint(randomTreeID, shortAvoidSettlement);
      // rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.5, 0.5, 5*cNumberNonGaiaPlayers);
         rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.5, 0.30, 1);
/*================================================================================================================*/
// *********************************** DEFINE AND PLACE THE RANDOM TREE 2: ************************************** //
/*================================================================================================================*/
      int randomTree2ID=rmCreateObjectDef("random tree 2");
      rmAddObjectDefItem(randomTree2ID, "TreePatagoniaDirt", rmRandInt(7,12), 6.0);
      rmSetObjectDefMinDistance(randomTree2ID, 0.0);
      //rmSetObjectDefMaxDistance(randomTree2ID, rmXFractionToMeters(0.5));
	    rmSetObjectDefMaxDistance(randomTree2ID, 0.0);
      rmAddObjectDefConstraint(randomTree2ID, rmCreateTypeDistanceConstraint("random tree two", "all", 2.0));
      //rmAddObjectDefConstraint(randomTree2ID, shortAvoidImpassableLand);
      //rmAddObjectDefConstraint(randomTree2ID, shortAvoidSettlement);
      // rmPlaceObjectDefAtLoc(randomTree2ID, 0, 0.5, 0.5, 2*cNumberNonGaiaPlayers);
         rmPlaceObjectDefAtLoc(randomTree2ID, 0, 0.35, 0.35, 1);
/*================================================================================================================*/
// *********************************** DEFINE AND PLACE THE RANDOM TREE 3: ************************************** //
/*================================================================================================================*/
      int randomTree3ID=rmCreateObjectDef("random tree 3");
      rmAddObjectDefItem(randomTree3ID, "TreePatagoniaDirt", rmRandInt(7,12), 5.0);
      rmSetObjectDefMinDistance(randomTree3ID, 0.0);
      //rmSetObjectDefMaxDistance(randomTree3ID, rmXFractionToMeters(0.5));
	    rmSetObjectDefMaxDistance(randomTree3ID, 0.0);
      rmAddObjectDefConstraint(randomTree3ID, rmCreateTypeDistanceConstraint("random tree two", "all", 2.0));
      //rmAddObjectDefConstraint(randomTree3ID, shortAvoidImpassableLand);
      //rmAddObjectDefConstraint(randomTree3ID, shortAvoidSettlement);
      // rmPlaceObjectDefAtLoc(randomTree3ID, 0, 0.5, 0.5, 2*cNumberNonGaiaPlayers);
         rmPlaceObjectDefAtLoc(randomTree3ID, 0, 0.30, 0.45, 1);
/*================================================================================================================*/
// *********************************** DEFINE AND PLACE THE RANDOM TREE 4: ************************************** //
/*================================================================================================================*/
      int randomTree4ID=rmCreateObjectDef("random tree 4");
      rmAddObjectDefItem(randomTree4ID, "TreePatagoniaDirt", rmRandInt(7,12), 5.0);
      rmSetObjectDefMinDistance(randomTree4ID, 0.0);
      //rmSetObjectDefMaxDistance(randomTree4ID, rmXFractionToMeters(0.5));
	    rmSetObjectDefMaxDistance(randomTree4ID, 0.0);
      rmAddObjectDefConstraint(randomTree4ID, rmCreateTypeDistanceConstraint("random tree two", "all", 2.0));
      //rmAddObjectDefConstraint(randomTree4ID, shortAvoidImpassableLand);
      //rmAddObjectDefConstraint(randomTree4ID, shortAvoidSettlement);
      // rmPlaceObjectDefAtLoc(randomTree4ID, 0, 0.5, 0.5, 2*cNumberNonGaiaPlayers);
         rmPlaceObjectDefAtLoc(randomTree4ID, 0, 0.30, 0.55, 1);
/*================================================================================================================*/
// *********************************** DEFINE AND PLACE THE RANDOM TREE 5: ************************************** //
/*================================================================================================================*/
      int randomTree5ID=rmCreateObjectDef("random tree 5");
      rmAddObjectDefItem(randomTree5ID, "TreePatagoniaDirt", rmRandInt(7,12), 5.0);
      rmSetObjectDefMinDistance(randomTree5ID, 0.0);
      //rmSetObjectDefMaxDistance(randomTree5ID, rmXFractionToMeters(0.5));
	    rmSetObjectDefMaxDistance(randomTree5ID, 0.0);
      rmAddObjectDefConstraint(randomTree5ID, rmCreateTypeDistanceConstraint("random tree two", "all", 2.0));
      //rmAddObjectDefConstraint(randomTree5ID, shortAvoidImpassableLand);
      //rmAddObjectDefConstraint(randomTree5ID, shortAvoidSettlement);
      // rmPlaceObjectDefAtLoc(randomTree5ID, 0, 0.5, 0.5, 2*cNumberNonGaiaPlayers);
         rmPlaceObjectDefAtLoc(randomTree5ID, 0, 0.37, 0.67, 1);
/*================================================================================================================*/
// *********************************** DEFINE AND PLACE THE RANDOM TREE 6: ************************************** //
/*================================================================================================================*/
      int randomTree6ID=rmCreateObjectDef("random tree 6");
      rmAddObjectDefItem(randomTree6ID, "TreePatagoniaDirt", rmRandInt(7,12), 5.0);
      rmSetObjectDefMinDistance(randomTree6ID, 0.0);
      //rmSetObjectDefMaxDistance(randomTree6ID, rmXFractionToMeters(0.5));
	    rmSetObjectDefMaxDistance(randomTree6ID, 0.0);
      rmAddObjectDefConstraint(randomTree6ID, rmCreateTypeDistanceConstraint("random tree two", "all", 2.0));
      //rmAddObjectDefConstraint(randomTree6ID, shortAvoidImpassableLand);
      //rmAddObjectDefConstraint(randomTree6ID, shortAvoidSettlement);
      // rmPlaceObjectDefAtLoc(randomTree6ID, 0, 0.5, 0.5, 2*cNumberNonGaiaPlayers);
         rmPlaceObjectDefAtLoc(randomTree6ID, 0, 0.51, 0.70, 1);	
/*================================================================================================================*/
// *********************************** DEFINE AND PLACE THE RANDOM TREE 7: ************************************** //
/*================================================================================================================*/
      int randomTree7ID=rmCreateObjectDef("random tree 7");
      rmAddObjectDefItem(randomTree7ID, "TreePatagoniaDirt", rmRandInt(7,12), 5.0);
      rmSetObjectDefMinDistance(randomTree7ID, 0.0);
      //rmSetObjectDefMaxDistance(randomTree7ID, rmXFractionToMeters(0.5));
	    rmSetObjectDefMaxDistance(randomTree7ID, 0.0);
      rmAddObjectDefConstraint(randomTree7ID, rmCreateTypeDistanceConstraint("random tree two", "all", 2.0));
      //rmAddObjectDefConstraint(randomTree7ID, shortAvoidImpassableLand);
      //rmAddObjectDefConstraint(randomTree7ID, shortAvoidSettlement);
      // rmPlaceObjectDefAtLoc(randomTree7ID, 0, 0.5, 0.5, 2*cNumberNonGaiaPlayers);
         rmPlaceObjectDefAtLoc(randomTree7ID, 0, 0.62, 0.67, 1);
/*================================================================================================================*/
// *********************************** DEFINE AND PLACE THE RANDOM TREE 8: ************************************** //
/*================================================================================================================*/
      int randomTree8ID=rmCreateObjectDef("random tree 8");
      rmAddObjectDefItem(randomTree8ID, "TreePatagoniaDirt", rmRandInt(7,12), 5.0);
      rmSetObjectDefMinDistance(randomTree8ID, 0.0);
      //rmSetObjectDefMaxDistance(randomTree8ID, rmXFractionToMeters(0.5));
	    rmSetObjectDefMaxDistance(randomTree8ID, 0.0);
      rmAddObjectDefConstraint(randomTree8ID, rmCreateTypeDistanceConstraint("random tree two", "all", 2.0));
      //rmAddObjectDefConstraint(randomTree8ID, shortAvoidImpassableLand);
      //rmAddObjectDefConstraint(randomTree8ID, shortAvoidSettlement);
      // rmPlaceObjectDefAtLoc(randomTree8ID, 0, 0.5, 0.5, 2*cNumberNonGaiaPlayers);
         rmPlaceObjectDefAtLoc(randomTree8ID, 0, 0.70, 0.52, 1);
/*================================================================================================================*/
// *********************************** DEFINE AND PLACE THE RANDOM TREE 9: ************************************** //
/*================================================================================================================*/
      int randomTree9ID=rmCreateObjectDef("random tree 9");
      rmAddObjectDefItem(randomTree9ID, "TreePatagoniaDirt", rmRandInt(7,12), 5.0);
      rmSetObjectDefMinDistance(randomTree9ID, 0.0);
      //rmSetObjectDefMaxDistance(randomTree9ID, rmXFractionToMeters(0.5));
	    rmSetObjectDefMaxDistance(randomTree9ID, 0.0);
      rmAddObjectDefConstraint(randomTree9ID, rmCreateTypeDistanceConstraint("random tree two", "all", 2.0));
      //rmAddObjectDefConstraint(randomTree9ID, shortAvoidImpassableLand);
      //rmAddObjectDefConstraint(randomTree9ID, shortAvoidSettlement);
      // rmPlaceObjectDefAtLoc(randomTree9ID, 0, 0.5, 0.5, 2*cNumberNonGaiaPlayers);
         rmPlaceObjectDefAtLoc(randomTree9ID, 0, 0.68, 0.40, 1);
/*================================================================================================================*/
// *********************************** DEFINE AND PLACE THE RANDOM TREE 10: ************************************** //
/*================================================================================================================*/
      int randomTree10ID=rmCreateObjectDef("random tree 10");
      rmAddObjectDefItem(randomTree10ID, "TreePatagoniaDirt", rmRandInt(7,12), 5.0);
      rmSetObjectDefMinDistance(randomTree10ID, 0.0);
      //rmSetObjectDefMaxDistance(randomTree10ID, rmXFractionToMeters(0.5));
	    rmSetObjectDefMaxDistance(randomTree10ID, 0.0);
      rmAddObjectDefConstraint(randomTree10ID, rmCreateTypeDistanceConstraint("random tree two", "all", 2.0));
      //rmAddObjectDefConstraint(randomTree10ID, shortAvoidImpassableLand);
      //rmAddObjectDefConstraint(randomTree10ID, shortAvoidSettlement);
      // rmPlaceObjectDefAtLoc(randomTree10ID, 0, 0.5, 0.5, 2*cNumberNonGaiaPlayers);
         rmPlaceObjectDefAtLoc(randomTree10ID, 0, 0.57, 0.34, 1);
/*================================================================================================================*/
         // *********************************** DEFINE AND PLACE THE RANDOM TREE 11: ************************************** //
/*================================================================================================================*/
          int randomTree11ID=rmCreateObjectDef("random tree 11");
          // rmAddObjectDefItem(randomTree11ID, "TreePatagoniaDirt", rmRandInt(7,12), 5.0);
		     rmAddObjectDefItem(randomTree11ID, "TreePatagoniaDirt", 1, 4.0);
          rmSetObjectDefMinDistance(randomTree11ID, 0.0);
          rmSetObjectDefMaxDistance(randomTree11ID, rmXFractionToMeters(0.5));
	        //rmSetObjectDefMaxDistance(randomTree11ID, 0.0);
          rmAddObjectDefConstraint(randomTree11ID, rmCreateTypeDistanceConstraint("random tree two", "all", 2.0));
          rmAddObjectDefConstraint(randomTree11ID, avoidWater4);
          rmAddObjectDefConstraint(randomTree11ID, avoidNuggetClose);
		  rmAddObjectDefConstraint(randomTree11ID, avoidGoldClose);
          // rmPlaceObjectDefAtLoc(randomTree11ID, 0, 0.5, 0.5, 2*cNumberNonGaiaPlayers);
          //rmPlaceObjectDefAtLoc(randomTree11ID, 0, 0.57, 0.34, 1);
          //for(i=1; <cNumberPlayers)
          rmPlaceObjectDefInArea(randomTree11ID, 0, smallMesaID, 25*cNumberNonGaiaPlayers);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.60);
/*================================================================================================================*/   
// ************************************* DEFINE AND PLACE RANDOM TREES: ***************************************** //
/*================================================================================================================*/
        int TreeID= rmCreateObjectDef("tree"); 
		//rmAddObjectDefItem(TreeID, "TreeSaguenay", 1, 0.0);
		//rmAddObjectDefItem(TreeID, "TreeGreatLakesSnow", rmRandInt(1,3), 4.0);
		rmAddObjectDefItem(TreeID, "TreePatagoniaDirt", 1, 0.0);
		rmSetObjectDefMinDistance(TreeID, 0.0);
        rmSetObjectDefMaxDistance(TreeID, rmXFractionToMeters(0.5));
		rmAddObjectDefConstraint(TreeID, rmCreateTypeDistanceConstraint("TreePatagoniaDirt", "all", 2.0));
		rmAddObjectDefConstraint(TreeID, avoidImpassableLand);
  		rmAddObjectDefConstraint(TreeID, avoidNugget);
  		//rmAddObjectDefConstraint(TreeID, avoidBerries);
		rmAddObjectDefConstraint(TreeID, avoidFruits);
		rmAddObjectDefConstraint(TreeID, avoidPronghorn);
		rmAddObjectDefConstraint(TreeID, playerConstraint);
		rmAddObjectDefConstraint(TreeID, avoidGold);
		rmAddObjectDefConstraint(TreeID, avoidBison);
		rmAddObjectDefConstraint(TreeID, avoidNatives);
  		rmAddObjectDefConstraint(TreeID, avoidAll);
		rmAddObjectDefConstraint(TreeID, avoidCow);
		rmAddObjectDefConstraint(TreeID, forestConstraint);
		rmAddObjectDefConstraint(TreeID, edgeConstraint);
		rmPlaceObjectDefAtLoc(TreeID, 0, 0.5, 0.5, 75);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.65);
/*================================================================================================================*/   
// ******************************** DEFINE AND PLACE THE FISHES -- FISHBASS: ************************************ //
/*================================================================================================================*/      
	  int fishID=rmCreateObjectDef("fish");
      rmAddObjectDefItem(fishID, "FishBass", 3, 9.0);
      rmSetObjectDefMinDistance(fishID, 0.0);
      rmSetObjectDefMaxDistance(fishID, rmXFractionToMeters(0.5));
      rmAddObjectDefConstraint(fishID, fishVsFishID);
      rmAddObjectDefConstraint(fishID, fishLand);
      // rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, 3*cNumberNonGaiaPlayers);
	     rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, 25*cNumberNonGaiaPlayers);
/*================================================================================================================*/
// ********************************* DEFINE AND PLACE THE FAST COIN -- WHALES *********************************** //	 
/*================================================================================================================*/
	  int whaleID=rmCreateObjectDef("whale");
      // rmAddObjectDefItem(whaleID, "beluga", 2, 9.0);
	     rmAddObjectDefItem(whaleID, "beluga", 1, 9.0);
      rmSetObjectDefMinDistance(whaleID, 0.0);
      rmSetObjectDefMaxDistance(whaleID, rmXFractionToMeters(0.5));
      rmAddObjectDefConstraint(whaleID, whaleVsWhaleID);
      rmAddObjectDefConstraint(whaleID, whaleLand);
      // rmPlaceObjectDefAtLoc(whaleID, 0, 0.5, 0.5, 2*cNumberNonGaiaPlayers);
	     rmPlaceObjectDefAtLoc(whaleID, 0, 0.5, 0.5, cNumberNonGaiaPlayers);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.70);
/*================================================================================================================*/   
// ************************************ DEFINE AND PLACE THE COLONY SHIPS: ************************************** //
/*================================================================================================================*/
        int colonyShipID = 0;
/*----------------------------------------------------------------------------------------------------------------*/		
        for(i=1; <cNumberPlayers)
/*----------------------------------------------------------------------------------------------------------------*/		
   {
		colonyShipID=rmCreateObjectDef("colony ship "+i);
	   	rmAddObjectDefItem(colonyShipID, "HomeCityWaterSpawnFlag", 1, 5.0);
		rmAddObjectDefConstraint(colonyShipID, shipVsShip);
		rmAddObjectDefConstraint(colonyShipID, fishLand);
		rmSetObjectDefMinDistance(colonyShipID, 0.0);
		rmSetObjectDefMaxDistance(colonyShipID, rmXFractionToMeters(0.35));
        		    
	   	// rmPlaceObjectDefAtLoc(colonyShipID, i, 1.0, 1.0, 1);
           rmPlaceObjectDefAtLoc(colonyShipID, i, 0.50, 0.50, 1); // testing...				
   }
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.75);
/*================================================================================================================*/   
// ************************************** DEFINE AND PLACE THE COWS 1: ****************************************** //
/*================================================================================================================*/
      int cowID=rmCreateObjectDef("The Cow 1");
      rmAddObjectDefItem(cowID, "cow", 5, 4.0);
      rmSetObjectDefMinDistance(cowID, 0.0);
      // rmSetObjectDefMaxDistance(cowID, rmXFractionToMeters(0.5));
	     rmSetObjectDefMaxDistance(cowID, 0.0);
      rmAddObjectDefConstraint(cowID, avoidCow);
	  //rmAddObjectDefConstraint(cowID, avoidAll);
	  //rmAddObjectDefConstraint(cowID, playerConstraint);
	  //rmAddObjectDefConstraint(cowID, avoidCliffs);
      //rmAddObjectDefConstraint(cowID, avoidImpassableLand);
	  // rmPlaceObjectDefAtLoc(cowID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3);
         rmPlaceObjectDefAtLoc(cowID, 0, 0.5, 0.95, 1);
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE COWS 2: ****************************************** //
/*================================================================================================================*/
      int cow2ID=rmCreateObjectDef("The Cow 2");
      rmAddObjectDefItem(cow2ID, "cow", 5, 4.0);
      rmSetObjectDefMinDistance(cow2ID, 0.0);
      // rmSetObjectDefMaxDistance(cow2ID, rmXFractionToMeters(0.5));
	     rmSetObjectDefMaxDistance(cow2ID, 0.0);
      rmAddObjectDefConstraint(cow2ID, avoidCow);
	  //rmAddObjectDefConstraint(cow2ID, avoidAll);
	  //rmAddObjectDefConstraint(cow2ID, playerConstraint);
	  //rmAddObjectDefConstraint(cow2ID, avoidCliffs);
      //rmAddObjectDefConstraint(cow2ID, avoidImpassableLand);
	  // rmPlaceObjectDefAtLoc(cow2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3);
         rmPlaceObjectDefAtLoc(cow2ID, 0, 0.05, 0.55, 1);
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE COWS 3: ****************************************** //
/*================================================================================================================*/
      int cow3ID=rmCreateObjectDef("The Cow 3");
      rmAddObjectDefItem(cow3ID, "cow", 5, 4.0);
      rmSetObjectDefMinDistance(cow3ID, 0.0);
      // rmSetObjectDefMaxDistance(cow3ID, rmXFractionToMeters(0.5));
	     rmSetObjectDefMaxDistance(cow3ID, 0.0);
      rmAddObjectDefConstraint(cow3ID, avoidCow);
	  //rmAddObjectDefConstraint(cow3ID, avoidAll);
	  //rmAddObjectDefConstraint(cow3ID, playerConstraint);
	  //rmAddObjectDefConstraint(cow3ID, avoidCliffs);
      //rmAddObjectDefConstraint(cow3ID, avoidImpassableLand);
	  // rmPlaceObjectDefAtLoc(cow3ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3);
         rmPlaceObjectDefAtLoc(cow3ID, 0, 0.52, 0.07, 1);
/*================================================================================================================*/
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE COWS 4: ****************************************** //
/*================================================================================================================*/
      int cow4ID=rmCreateObjectDef("The Cow 4");
      rmAddObjectDefItem(cow4ID, "cow", 5, 4.0);
      rmSetObjectDefMinDistance(cow4ID, 0.0);
      // rmSetObjectDefMaxDistance(cow4ID, rmXFractionToMeters(0.5));
	     rmSetObjectDefMaxDistance(cow4ID, 0.0);
      rmAddObjectDefConstraint(cow4ID, avoidCow);
	  //rmAddObjectDefConstraint(cow4ID, avoidAll);
	  //rmAddObjectDefConstraint(cow4ID, playerConstraint);
	  //rmAddObjectDefConstraint(cow4ID, avoidCliffs);
      //rmAddObjectDefConstraint(cow4ID, avoidImpassableLand);
	  // rmPlaceObjectDefAtLoc(cow4ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3);
         rmPlaceObjectDefAtLoc(cow4ID, 0, 0.95, 0.4, 1);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.80);
/*================================================================================================================*/   
// ***************************** PLACE SOME EXTRA SMALL-ISH PRONGHORN HERDS 1: ********************************** //
/*================================================================================================================*/
      int pronghornID=rmCreateObjectDef("Pronghorn 1");
      // rmAddObjectDefItem(pronghornID, "pronghorn", 2, 3.0);
	     rmAddObjectDefItem(pronghornID, "pronghorn", rmRandInt(3,5), 8.0);
      rmSetObjectDefMinDistance(pronghornID, 0.0);
      // rmSetObjectDefMaxDistance(pronghornID, rmXFractionToMeters(0.5));
	     rmSetObjectDefMaxDistance(pronghornID, 0.0);
      rmAddObjectDefConstraint(pronghornID, avoidPronghorn);
      rmSetObjectDefCreateHerd(pronghornID, true);
      // rmPlaceObjectDefAtLoc(pronghornID, 0, 0.15, 0.3, cNumberNonGaiaPlayers*3);
         rmPlaceObjectDefAtLoc(pronghornID, 0, 0.15, 0.5, 1);
/*================================================================================================================*/
// ***************************** PLACE SOME EXTRA SMALL-ISH PRONGHORN HERDS 2: ********************************** //
/*================================================================================================================*/
      int pronghorn2ID=rmCreateObjectDef("Pronghorn 2");
      // rmAddObjectDefItem(pronghorn2ID, "pronghorn", 2, 3.0);
	     rmAddObjectDefItem(pronghorn2ID, "pronghorn", rmRandInt(3,5), 8.0);
      rmSetObjectDefMinDistance(pronghorn2ID, 0.0);
      // rmSetObjectDefMaxDistance(pronghorn2ID, rmXFractionToMeters(0.5));
	     rmSetObjectDefMaxDistance(pronghorn2ID, 0.0);
      rmAddObjectDefConstraint(pronghorn2ID, avoidPronghorn);
      rmSetObjectDefCreateHerd(pronghorn2ID, true);
      // rmPlaceObjectDefAtLoc(pronghorn2ID, 0, 0.15, 0.3, cNumberNonGaiaPlayers*3);
         rmPlaceObjectDefAtLoc(pronghorn2ID, 0, 0.38, 0.08, 1);	
/*================================================================================================================*/
// ***************************** PLACE SOME EXTRA SMALL-ISH PRONGHORN HERDS 3: ********************************** //
/*================================================================================================================*/
      int pronghorn3ID=rmCreateObjectDef("Pronghorn 3");
      // rmAddObjectDefItem(pronghorn3ID, "pronghorn", 2, 3.0);
	     rmAddObjectDefItem(pronghorn3ID, "pronghorn", rmRandInt(3,5), 8.0);
      rmSetObjectDefMinDistance(pronghorn3ID, 0.0);
      // rmSetObjectDefMaxDistance(pronghorn3ID, rmXFractionToMeters(0.5));
	     rmSetObjectDefMaxDistance(pronghorn3ID, 0.0);
      rmAddObjectDefConstraint(pronghorn3ID, avoidPronghorn);
      rmSetObjectDefCreateHerd(pronghorn3ID, true);
      // rmPlaceObjectDefAtLoc(pronghorn3ID, 0, 0.15, 0.3, cNumberNonGaiaPlayers*3);
         rmPlaceObjectDefAtLoc(pronghorn3ID, 0, 0.85, 0.35, 1);	
/*================================================================================================================*/
// ***************************** PLACE SOME EXTRA SMALL-ISH PRONGHORN HERDS 4: ********************************** //
/*================================================================================================================*/
      int pronghorn4ID=rmCreateObjectDef("Pronghorn 4");
      // rmAddObjectDefItem(pronghorn4ID, "pronghorn", 2, 3.0);
	     rmAddObjectDefItem(pronghorn4ID, "pronghorn", rmRandInt(3,5), 8.0);
      rmSetObjectDefMinDistance(pronghorn4ID, 0.0);
      // rmSetObjectDefMaxDistance(pronghorn4ID, rmXFractionToMeters(0.5));
	     rmSetObjectDefMaxDistance(pronghorn4ID, 0.0);
      rmAddObjectDefConstraint(pronghorn4ID, avoidPronghorn);
      rmSetObjectDefCreateHerd(pronghorn4ID, true);
      // rmPlaceObjectDefAtLoc(pronghorn4ID, 0, 0.15, 0.3, cNumberNonGaiaPlayers*3);
         rmPlaceObjectDefAtLoc(pronghorn4ID, 0, 0.35, 0.80, 1);	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.85);
/*================================================================================================================*/   
// *********************************** DEFINE AND PLACE SCATTERED BERRIES 1: ************************************** //
/*================================================================================================================*/		
	  int berriesID=rmCreateObjectDef("random berries");
	  rmAddObjectDefItem(berriesID, "berrybush", rmRandInt(3,5), 6.0);  // (3,5) is unit count range.  6.0 is float cluster - the range area the objects can be placed.
	  rmSetObjectDefMinDistance(berriesID, 0.0);
	  //rmSetObjectDefMaxDistance(berriesID, rmXFractionToMeters(0.5));
	  rmSetObjectDefMaxDistance(berriesID, 0.0);
	  rmAddObjectDefConstraint(berriesID, avoidFruits);
	  rmPlaceObjectDefAtLoc(berriesID, 0, 0.25, 0.70, 1);  
/*================================================================================================================*/
// ********************************** DEFINE AND PLACE SCATTERED BERRIES 2: ************************************* //
/*================================================================================================================*/		
	  int berries2ID=rmCreateObjectDef("random berries 2");
	  rmAddObjectDefItem(berries2ID, "berrybush", rmRandInt(3,5), 6.0);  // (3,5) is unit count range.  6.0 is float cluster - the range area the objects can be placed.
	  rmSetObjectDefMinDistance(berries2ID, 0.0);
	  //rmSetObjectDefMaxDistance(berries2ID, rmXFractionToMeters(0.5));
	  rmSetObjectDefMaxDistance(berries2ID, 0.0);
	  rmAddObjectDefConstraint(berries2ID, avoidFruits);
	  rmPlaceObjectDefAtLoc(berries2ID, 0, 0.93, 0.50, 1); 
/*================================================================================================================*/
// ********************************** DEFINE AND PLACE SCATTERED BERRIES 3: ************************************* //
/*================================================================================================================*/		
	  int berries3ID=rmCreateObjectDef("random berries 3");
	  rmAddObjectDefItem(berries3ID, "berrybush", rmRandInt(3,5), 6.0);  // (3,5) is unit count range.  6.0 is float cluster - the range area the objects can be placed.
	  rmSetObjectDefMinDistance(berries3ID, 0.0);
	  //rmSetObjectDefMaxDistance(berries3ID, rmXFractionToMeters(0.5));
	  rmSetObjectDefMaxDistance(berries3ID, 0.0);
	  rmAddObjectDefConstraint(berries3ID, avoidFruits);
	  rmPlaceObjectDefAtLoc(berries3ID, 0, 0.6, 0.08, 1); 
/*================================================================================================================*/
// ********************************** DEFINE AND PLACE SCATTERED BERRIES 4: ************************************* //
/*================================================================================================================*/		
	  int berries4ID=rmCreateObjectDef("random berries 4");
	  rmAddObjectDefItem(berries4ID, "berrybush", rmRandInt(3,5), 6.0);  // (3,5) is unit count range.  6.0 is float cluster - the range area the objects can be placed.
	  rmSetObjectDefMinDistance(berries4ID, 0.0);
	  //rmSetObjectDefMaxDistance(berries4ID, rmXFractionToMeters(0.5));
	  rmSetObjectDefMaxDistance(berries4ID, 0.0);
	  rmAddObjectDefConstraint(berries4ID, avoidFruits);
	  rmPlaceObjectDefAtLoc(berries4ID, 0, 0.6, 0.8, 1);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.90);
/*================================================================================================================*/   
// ************************************* DEFINE AND PLACE THE NUGGETS 1: **************************************** //
/*================================================================================================================*/
	  int nugget1ID= rmCreateObjectDef("nugget easy 1"); 
	  rmAddObjectDefItem(nugget1ID, "Nugget", 1, 0.0);
	  rmSetObjectDefMinDistance(nugget1ID, 0.0);
	  rmSetNuggetDifficulty(1, 1);
	  // rmSetObjectDefMaxDistance(nugget1ID, rmXFractionToMeters(0.5));
	     rmSetObjectDefMaxDistance(nugget1ID, 0.0);
	  rmAddObjectDefConstraint(nugget1ID, avoidNugget);
	  rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.62, 0.93, 1);	
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE NUGGETS 2: **************************************** //
/*================================================================================================================*/
	  int nugget2ID= rmCreateObjectDef("nugget easy 2"); 
	  rmAddObjectDefItem(nugget2ID, "Nugget", 1, 0.0);
	  rmSetObjectDefMinDistance(nugget2ID, 0.0);
	  rmSetNuggetDifficulty(1, 1);
	  // rmSetObjectDefMaxDistance(nugget2ID, rmXFractionToMeters(0.5));
	     rmSetObjectDefMaxDistance(nugget2ID, 0.0);
	  rmAddObjectDefConstraint(nugget2ID, avoidNugget);
	  rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.42, 0.95, 1);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE NUGGETS 3: **************************************** //
/*================================================================================================================*/
	  int nugget3ID= rmCreateObjectDef("nugget easy 3"); 
	  rmAddObjectDefItem(nugget3ID, "Nugget", 1, 0.0);
	  rmSetObjectDefMinDistance(nugget3ID, 0.0);
	  rmSetNuggetDifficulty(1, 1);
	  // rmSetObjectDefMaxDistance(nugget3ID, rmXFractionToMeters(0.5));
	     rmSetObjectDefMaxDistance(nugget3ID, 0.0);
	  rmAddObjectDefConstraint(nugget3ID, avoidNugget);
	  rmPlaceObjectDefAtLoc(nugget3ID, 0, 0.65, 0.08, 1);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE NUGGETS 4: **************************************** //
/*================================================================================================================*/
	  int nugget4ID= rmCreateObjectDef("nugget easy 4"); 
	  rmAddObjectDefItem(nugget4ID, "Nugget", 1, 0.0);
	  rmSetObjectDefMinDistance(nugget4ID, 0.0);
	  rmSetNuggetDifficulty(1, 1);
	  // rmSetObjectDefMaxDistance(nugget4ID, rmXFractionToMeters(0.5));
	     rmSetObjectDefMaxDistance(nugget4ID, 0.0);
	  rmAddObjectDefConstraint(nugget4ID, avoidNugget);
	  rmPlaceObjectDefAtLoc(nugget4ID, 0, 0.31, 0.085, 1);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE NUGGETS 5: **************************************** //
/*================================================================================================================*/
	  int nugget5ID= rmCreateObjectDef("nugget easy 5"); 
	  rmAddObjectDefItem(nugget5ID, "Nugget", 1, 0.0);
	  rmSetObjectDefMinDistance(nugget5ID, 0.0);
	  rmSetNuggetDifficulty(1, 1);
	  // rmSetObjectDefMaxDistance(nugget5ID, rmXFractionToMeters(0.5));
	     rmSetObjectDefMaxDistance(nugget5ID, 0.0);
	  rmAddObjectDefConstraint(nugget5ID, avoidNugget);
	  rmPlaceObjectDefAtLoc(nugget5ID, 0, 0.11, 0.75, 1);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE NUGGETS 6: **************************************** //
/*================================================================================================================*/
	  int nugget6ID= rmCreateObjectDef("nugget easy 6"); 
	  rmAddObjectDefItem(nugget6ID, "Nugget", 1, 0.0);
	  rmSetObjectDefMinDistance(nugget6ID, 0.0);
	  rmSetNuggetDifficulty(1, 1);
	  // rmSetObjectDefMaxDistance(nugget6ID, rmXFractionToMeters(0.5));
	     rmSetObjectDefMaxDistance(nugget6ID, 0.0);
	  rmAddObjectDefConstraint(nugget6ID, avoidNugget);
	  rmPlaceObjectDefAtLoc(nugget6ID, 0, 0.06, 0.48, 1);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE NUGGETS 7: **************************************** //
/*================================================================================================================*/
	  int nugget7ID= rmCreateObjectDef("nugget easy 7"); 
	  rmAddObjectDefItem(nugget7ID, "Nugget", 1, 0.0);
	  rmSetObjectDefMinDistance(nugget7ID, 0.0);
	  rmSetNuggetDifficulty(1, 1);
	  // rmSetObjectDefMaxDistance(nugget7ID, rmXFractionToMeters(0.5));
	     rmSetObjectDefMaxDistance(nugget7ID, 0.0);
	  rmAddObjectDefConstraint(nugget7ID, avoidNugget);
	  rmPlaceObjectDefAtLoc(nugget7ID, 0, 0.85, 0.25, 1);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE NUGGETS 8: **************************************** //
/*================================================================================================================*/
	  int nugget8ID= rmCreateObjectDef("nugget easy 8"); 
	  rmAddObjectDefItem(nugget8ID, "Nugget", 1, 0.0);
	  rmSetObjectDefMinDistance(nugget8ID, 0.0);
	  rmSetNuggetDifficulty(1, 1);
	  // rmSetObjectDefMaxDistance(nugget8ID, rmXFractionToMeters(0.5));
	     rmSetObjectDefMaxDistance(nugget8ID, 0.0);
	  rmAddObjectDefConstraint(nugget8ID, avoidNugget);
	  rmPlaceObjectDefAtLoc(nugget8ID, 0, 0.80, 0.55, 1);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE NUGGETS 9: **************************************** //
/*================================================================================================================*/
	  int nugget9ID= rmCreateObjectDef("nugget easy 9"); 
	  rmAddObjectDefItem(nugget9ID, "Nugget", 1, 0.0);
	  rmSetObjectDefMinDistance(nugget9ID, 0.0);
	  rmSetNuggetDifficulty(1, 1);
	  // rmSetObjectDefMaxDistance(nugget9ID, rmXFractionToMeters(0.5));
	     rmSetObjectDefMaxDistance(nugget9ID, 0.0);
	  rmAddObjectDefConstraint(nugget9ID, avoidNugget);
	  rmPlaceObjectDefAtLoc(nugget9ID, 0, 0.40, 0.32, 1);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE NUGGETS 10: *************************************** //
/*================================================================================================================*/
	  int nugget10ID= rmCreateObjectDef("nugget easy 10"); 
	  rmAddObjectDefItem(nugget10ID, "Nugget", 1, 0.0);
	  rmSetObjectDefMinDistance(nugget10ID, 0.0);
	  rmSetNuggetDifficulty(1, 1);
	  // rmSetObjectDefMaxDistance(nugget10ID, rmXFractionToMeters(0.5));
	     rmSetObjectDefMaxDistance(nugget10ID, 0.0);
	  rmAddObjectDefConstraint(nugget10ID, avoidNugget);
	  rmPlaceObjectDefAtLoc(nugget10ID, 0, 0.35, 0.65, 1);	
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE NUGGETS 11: *************************************** //
/*================================================================================================================*/
	  int nugget11ID= rmCreateObjectDef("nugget easy 11"); 
	  rmAddObjectDefItem(nugget11ID, "Nugget", 1, 0.0);
	  rmSetObjectDefMinDistance(nugget11ID, 0.0);
	  rmSetNuggetDifficulty(1, 1);
	  // rmSetObjectDefMaxDistance(nugget11ID, rmXFractionToMeters(0.5));
	     rmSetObjectDefMaxDistance(nugget11ID, 0.0);
	  rmAddObjectDefConstraint(nugget11ID, avoidNugget);
	  rmPlaceObjectDefAtLoc(nugget11ID, 0, 0.575, 0.675, 1);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE NUGGETS 12: *************************************** //
/*================================================================================================================*/
	  int nugget12ID= rmCreateObjectDef("nugget easy 12"); 
	  rmAddObjectDefItem(nugget12ID, "Nugget", 1, 0.0);
	  rmSetObjectDefMinDistance(nugget12ID, 0.0);
	  rmSetNuggetDifficulty(1, 1);
	  // rmSetObjectDefMaxDistance(nugget12ID, rmXFractionToMeters(0.5));
	     rmSetObjectDefMaxDistance(nugget12ID, 0.0);
	  rmAddObjectDefConstraint(nugget12ID, avoidNugget);
	  rmPlaceObjectDefAtLoc(nugget12ID, 0, 0.65, 0.375, 1);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.95);
/*================================================================================================================*/   
// **************************** THE VARIABLES NEEDED BY THE FORESTS AND THE CLIFFS: ***************************** //
/*================================================================================================================*/
        // Text
	    int numTries = -1;
	    int failCount = -1;
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE FORESTS 1: **************************************** //
/*================================================================================================================*/
         int forestTreeID = 0;
         //numTries=5*cNumberNonGaiaPlayers;
		   numTries=12;
         failCount=0;
/*----------------------------------------------------------------------------------------------------------------*/   
         for (i=0; <numTries)
/*----------------------------------------------------------------------------------------------------------------*/   
      { 
/*----------------------------------------------------------------------------------------------------------------*/	  
         //int forest=rmCreateArea("forest "+i);
		   int forest=rmCreateArea("forest"+i);
         rmSetAreaWarnFailure(forest, false);
         rmSetAreaSize(forest, rmAreaTilesToFraction(100), rmAreaTilesToFraction(100));
         //rmSetAreaForestType(forest, "texas forest");
		   // rmSetAreaForestType(forest, "great lakes forest snow");
		      rmSetAreaForestType(forest, "patagonia forest");
		 // rmSetAreaForestType(forest, "dunes");
         rmSetAreaForestDensity(forest, 0.9);
         rmSetAreaForestClumpiness(forest, 0.8);
         rmSetAreaForestUnderbrush(forest, 0.0);
         //rmSetAreaMinBlobs(forest, 1);
         //rmSetAreaMaxBlobs(forest, 5);
         //rmSetAreaMinBlobDistance(forest, 10.0);
         //rmSetAreaMaxBlobDistance(forest, 30.0);
         rmSetAreaCoherence(forest, 0.4);
         rmSetAreaSmoothDistance(forest, 10);
         rmAddAreaToClass(forest, rmClassID("classForest")); 
/*----------------------------------------------------------------------------------------------------------------*/         
		 rmAddAreaConstraint(forest, forestConstraint);
/*----------------------------------------------------------------------------------------------------------------*/		 
         rmAddAreaConstraint(forest, avoidAll);
		 rmAddAreaConstraint(forest, avoidNugget);
		 //rmAddAreaConstraint(forest, avoidDeer);
		 rmAddAreaConstraint(forest, avoidBison);
		 rmAddAreaConstraint(forest, forestAvoidForest);
		 rmAddAreaConstraint(forest, avoidNatives);
		 //rmAddAreaConstraint(forest, playerConstraintForest);
		 rmAddAreaConstraint(forest, avoidGold);
		 rmAddAreaConstraint(forest, avoidCow);
		 //rmAddAreaConstraint(forest, avoidMoose);
		 rmAddAreaConstraint(forest, edgeConstraint);
         rmAddAreaConstraint(forest, avoidCliffs); 
         rmAddAreaConstraint(forest, avoidImpassableLand); 
         rmAddAreaConstraint(forest, avoidFruits); 
		 rmAddAreaConstraint(forest, Northward); 
		 rmAddAreaConstraint(forest, avoidStartingUnits);
         rmAddAreaConstraint(forest, smallMesaConstraint); 		 
/*----------------------------------------------------------------------------------------------------------------*/         
		 if(rmBuildArea(forest)==false)
         {
            // Stop trying once we fail 3 times in a row.
            failCount++;
            if(failCount==5)
               break;
         }
         else
            failCount=0; 
/*----------------------------------------------------------------------------------------------------------------*/			
      } 
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE FORESTS 2: **************************************** //
/*================================================================================================================*/
         //int forestTreeID = 0;
         //numTries=5*cNumberNonGaiaPlayers;
		   numTries=12;
         failCount=0;
/*----------------------------------------------------------------------------------------------------------------*/   
         for (i=0; <numTries)
/*----------------------------------------------------------------------------------------------------------------*/   
      { 
/*----------------------------------------------------------------------------------------------------------------*/	  
         //int forest2=rmCreateArea("forest 2"+i);
		   int forest2=rmCreateArea("forest 2"+i);
         rmSetAreaWarnFailure(forest2, false);
         //rmSetAreaSize(forest2, rmAreaTilesToFraction(75), rmAreaTilesToFraction(125));
		   rmSetAreaSize(forest2, rmAreaTilesToFraction(100), rmAreaTilesToFraction(100));
         //rmSetAreaForestType(forest2, "texas forest");
		   // rmSetAreaForestType(forest2, "great lakes forest snow");
		      rmSetAreaForestType(forest2, "patagonia forest");
		 // rmSetAreaForestType(forest2, "dunes");
         rmSetAreaForestDensity(forest2, 0.9);
         rmSetAreaForestClumpiness(forest2, 0.8);
         rmSetAreaForestUnderbrush(forest2, 0.0);
         //rmSetAreaMinBlobs(forest2, 1);
         //rmSetAreaMaxBlobs(forest2, 5);
         //rmSetAreaMinBlobDistance(forest2, 10.0);
         //rmSetAreaMaxBlobDistance(forest2, 30.0);
         rmSetAreaCoherence(forest2, 0.4);
         rmSetAreaSmoothDistance(forest2, 10);
         rmAddAreaToClass(forest2, rmClassID("classForest")); 
/*----------------------------------------------------------------------------------------------------------------*/         
		 rmAddAreaConstraint(forest2, forestConstraint);
/*----------------------------------------------------------------------------------------------------------------*/		 
         rmAddAreaConstraint(forest2, avoidAll);
		 rmAddAreaConstraint(forest2, avoidNugget);
		 //rmAddAreaConstraint(forest2, avoidDeer);
		 rmAddAreaConstraint(forest2, forestAvoidForest);
		 rmAddAreaConstraint(forest2, avoidNatives);
		 //rmAddAreaConstraint(forest2, playerConstraintForest);
		 rmAddAreaConstraint(forest2, avoidGold);
		 rmAddAreaConstraint(forest2, avoidBison);
		 rmAddAreaConstraint(forest2, avoidCow);
		 //rmAddAreaConstraint(forest2, avoidMoose);
		 rmAddAreaConstraint(forest2, edgeConstraint);
         //rmAddAreaConstraint(forest2, avoidCliffs); 
         rmAddAreaConstraint(forest2, avoidImpassableLand); 
         rmAddAreaConstraint(forest2, avoidFruits); 
		 rmAddAreaConstraint(forest2, Southward); 
		 rmAddAreaConstraint(forest2, avoidStartingUnits); 
		// rmAddAreaConstraint(forest2, smallMesaConstraint); 	
/*----------------------------------------------------------------------------------------------------------------*/         
		 if(rmBuildArea(forest2)==false)
         {
            // Stop trying once we fail 3 times in a row.
            failCount++;
            if(failCount==5)
               break;
         }
         else
            failCount=0; 
/*----------------------------------------------------------------------------------------------------------------*/			
      } 
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE FORESTS 3: **************************************** //
/*================================================================================================================*/
         //int forestTreeID = 0;
         //numTries=5*cNumberNonGaiaPlayers;
		   numTries=12;
         failCount=0;
/*----------------------------------------------------------------------------------------------------------------*/   
         for (i=0; <numTries)
/*----------------------------------------------------------------------------------------------------------------*/   
      { 
/*----------------------------------------------------------------------------------------------------------------*/	  
         //int forest3=rmCreateArea("forest 3"+i);
		   int forest3=rmCreateArea("forest 3"+i);
         rmSetAreaWarnFailure(forest3, false);
         //rmSetAreaSize(forest3, rmAreaTilesToFraction(75), rmAreaTilesToFraction(125));
		   rmSetAreaSize(forest3, rmAreaTilesToFraction(100), rmAreaTilesToFraction(100));
         //rmSetAreaForestType(forest3, "texas forest");
		   //rmSetAreaForestType(forest3, "great lakes forest snow");
		     rmSetAreaForestType(forest3, "patagonia forest");
		 // rmSetAreaForestType(forest3, "dunes");
         rmSetAreaForestDensity(forest3, 0.9);
         rmSetAreaForestClumpiness(forest3, 0.8);
         rmSetAreaForestUnderbrush(forest3, 0.0);
         //rmSetAreaMinBlobs(forest3, 1);
         //rmSetAreaMaxBlobs(forest3, 5);
         //rmSetAreaMinBlobDistance(forest3, 10.0);
         //rmSetAreaMaxBlobDistance(forest3, 30.0);
         rmSetAreaCoherence(forest3, 0.4);
         rmSetAreaSmoothDistance(forest3, 10);
         rmAddAreaToClass(forest3, rmClassID("classForest")); 
/*----------------------------------------------------------------------------------------------------------------*/         
		 rmAddAreaConstraint(forest3, forestConstraint);
/*----------------------------------------------------------------------------------------------------------------*/		 
         rmAddAreaConstraint(forest3, avoidAll);
		 rmAddAreaConstraint(forest3, avoidNugget);
		 //rmAddAreaConstraint(forest3, avoidDeer);
		 rmAddAreaConstraint(forest3, avoidPronghorn);
		 rmAddAreaConstraint(forest3, avoidBison);
		 rmAddAreaConstraint(forest3, forestAvoidForest);
		 rmAddAreaConstraint(forest3, avoidNatives);
		 //rmAddAreaConstraint(forest3, playerConstraintForest);
		 rmAddAreaConstraint(forest3, avoidGold);
		 rmAddAreaConstraint(forest3, avoidCow);
		 //rmAddAreaConstraint(forest3, avoidMoose);
		 rmAddAreaConstraint(forest3, edgeConstraint);
         //rmAddAreaConstraint(forest3, avoidCliffs); 
         rmAddAreaConstraint(forest3, avoidImpassableLand); 
         rmAddAreaConstraint(forest3, avoidFruits); 
		 rmAddAreaConstraint(forest3, Eastward); 
		 rmAddAreaConstraint(forest3, avoidStartingUnits);
         rmAddAreaConstraint(forest3, smallMesaConstraint); 			 
/*----------------------------------------------------------------------------------------------------------------*/         
		 if(rmBuildArea(forest3)==false)
         {
            // Stop trying once we fail 3 times in a row.
            failCount++;
            if(failCount==5)
               break;
         }
         else
            failCount=0; 
/*----------------------------------------------------------------------------------------------------------------*/			
      } 
/*================================================================================================================*/  
// ************************************* DEFINE AND PLACE THE FORESTS 4: **************************************** //
/*================================================================================================================*/
         //int forestTreeID = 0;
         //numTries=5*cNumberNonGaiaPlayers;
		   numTries=12;
         failCount=0;
/*----------------------------------------------------------------------------------------------------------------*/   
         for (i=0; <numTries)
/*----------------------------------------------------------------------------------------------------------------*/   
      { 
/*----------------------------------------------------------------------------------------------------------------*/	  
         //int forest4=rmCreateArea("forest 4"+i);
		   int forest4=rmCreateArea("forest 4"+i);
         rmSetAreaWarnFailure(forest4, false);
         //rmSetAreaSize(forest4, rmAreaTilesToFraction(75), rmAreaTilesToFraction(125));
		   rmSetAreaSize(forest4, rmAreaTilesToFraction(100), rmAreaTilesToFraction(100));
         //rmSetAreaForestType(forest4, "texas forest");
		   //rmSetAreaForestType(forest4, "great lakes forest snow");
		     rmSetAreaForestType(forest4, "patagonia forest");
		 // rmSetAreaForestType(forest4, "dunes");
         rmSetAreaForestDensity(forest4, 0.9);
         rmSetAreaForestClumpiness(forest4, 0.8);
         rmSetAreaForestUnderbrush(forest4, 0.0);
         //rmSetAreaMinBlobs(forest4, 1);
         //rmSetAreaMaxBlobs(forest4, 5);
         //rmSetAreaMinBlobDistance(forest4, 10.0);
         //rmSetAreaMaxBlobDistance(forest4, 30.0);
         rmSetAreaCoherence(forest4, 0.4);
         rmSetAreaSmoothDistance(forest4, 10);
         rmAddAreaToClass(forest4, rmClassID("classForest")); 
/*----------------------------------------------------------------------------------------------------------------*/         
		 rmAddAreaConstraint(forest4, forestConstraint);
/*----------------------------------------------------------------------------------------------------------------*/		 
         rmAddAreaConstraint(forest4, avoidAll);
		 rmAddAreaConstraint(forest4, avoidNugget);
		 rmAddAreaConstraint(forest4, avoidPronghorn);
		 rmAddAreaConstraint(forest4, avoidBison);
		 rmAddAreaConstraint(forest4, avoidGold);
		 rmAddAreaConstraint(forest4, avoidCow);
		 rmAddAreaConstraint(forest4, forestAvoidForest);
		 rmAddAreaConstraint(forest4, avoidNatives);
		 //rmAddAreaConstraint(forest4, playerConstraintForest);
		 rmAddAreaConstraint(forest4, edgeConstraint);
         //rmAddAreaConstraint(forest4, avoidCliffs); 
         rmAddAreaConstraint(forest4, avoidImpassableLand); 
         rmAddAreaConstraint(forest4, avoidFruits); 
		 rmAddAreaConstraint(forest4, Westward); 
		 rmAddAreaConstraint(forest4, avoidStartingUnits); 
		 rmAddAreaConstraint(forest4, smallMesaConstraint); 
/*----------------------------------------------------------------------------------------------------------------*/         
		 if(rmBuildArea(forest4)==false)
         {
            // Stop trying once we fail 3 times in a row.
            failCount++;
            if(failCount==5)
               break;
         }
         else
            failCount=0; 
/*----------------------------------------------------------------------------------------------------------------*/			
      } 
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",1.00);
/*================================================================================================================*/   
}  
/*----------------------------------------------------------------------------------------------------------------*/
// ************************************ THIS IS THE END OF THE MAP: ********************************************* //
/*----------------------------------------------------------------------------------------------------------------*/		
